/* A Bison parser, made by GNU Bison 1.875.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     TOK_ANY = 258,
     TOK_ATTRIBUTE = 259,
     TOK_BOOLEAN = 260,
     TOK_CASE = 261,
     TOK_CHAR = 262,
     TOK_CONST = 263,
     TOK_CONTEXT = 264,
     TOK_DEFAULT = 265,
     TOK_DOUBLE = 266,
     TOK_ENUM = 267,
     TOK_EXCEPTION = 268,
     TOK_FALSE = 269,
     TOK_FIXED = 270,
     TOK_FLOAT = 271,
     TOK_IN = 272,
     TOK_INOUT = 273,
     TOK_INTERFACE = 274,
     TOK_LONG = 275,
     TOK_MODULE = 276,
     TOK_NATIVE = 277,
     TOK_OBJECT = 278,
     TOK_OCTET = 279,
     TOK_ONEWAY = 280,
     TOK_OP_SCOPE = 281,
     TOK_OP_SHL = 282,
     TOK_OP_SHR = 283,
     TOK_OUT = 284,
     TOK_RAISES = 285,
     TOK_READONLY = 286,
     TOK_SEQUENCE = 287,
     TOK_SHORT = 288,
     TOK_STRING = 289,
     TOK_STRUCT = 290,
     TOK_SWITCH = 291,
     TOK_TRUE = 292,
     TOK_TYPECODE = 293,
     TOK_TYPEDEF = 294,
     TOK_UNION = 295,
     TOK_UNSIGNED = 296,
     TOK_VARARGS = 297,
     TOK_VOID = 298,
     TOK_WCHAR = 299,
     TOK_WSTRING = 300,
     TOK_FLOATP = 301,
     TOK_INTEGER = 302,
     TOK_DECLSPEC = 303,
     TOK_PROP_KEY = 304,
     TOK_PROP_VALUE = 305,
     TOK_NATIVE_TYPE = 306,
     TOK_IDENT = 307,
     TOK_SQSTRING = 308,
     TOK_DQSTRING = 309,
     TOK_FIXEDP = 310,
     TOK_CODEFRAG = 311,
     TOK_SRCFILE = 312
   };
#endif
#define TOK_ANY 258
#define TOK_ATTRIBUTE 259
#define TOK_BOOLEAN 260
#define TOK_CASE 261
#define TOK_CHAR 262
#define TOK_CONST 263
#define TOK_CONTEXT 264
#define TOK_DEFAULT 265
#define TOK_DOUBLE 266
#define TOK_ENUM 267
#define TOK_EXCEPTION 268
#define TOK_FALSE 269
#define TOK_FIXED 270
#define TOK_FLOAT 271
#define TOK_IN 272
#define TOK_INOUT 273
#define TOK_INTERFACE 274
#define TOK_LONG 275
#define TOK_MODULE 276
#define TOK_NATIVE 277
#define TOK_OBJECT 278
#define TOK_OCTET 279
#define TOK_ONEWAY 280
#define TOK_OP_SCOPE 281
#define TOK_OP_SHL 282
#define TOK_OP_SHR 283
#define TOK_OUT 284
#define TOK_RAISES 285
#define TOK_READONLY 286
#define TOK_SEQUENCE 287
#define TOK_SHORT 288
#define TOK_STRING 289
#define TOK_STRUCT 290
#define TOK_SWITCH 291
#define TOK_TRUE 292
#define TOK_TYPECODE 293
#define TOK_TYPEDEF 294
#define TOK_UNION 295
#define TOK_UNSIGNED 296
#define TOK_VARARGS 297
#define TOK_VOID 298
#define TOK_WCHAR 299
#define TOK_WSTRING 300
#define TOK_FLOATP 301
#define TOK_INTEGER 302
#define TOK_DECLSPEC 303
#define TOK_PROP_KEY 304
#define TOK_PROP_VALUE 305
#define TOK_NATIVE_TYPE 306
#define TOK_IDENT 307
#define TOK_SQSTRING 308
#define TOK_DQSTRING 309
#define TOK_FIXEDP 310
#define TOK_CODEFRAG 311
#define TOK_SRCFILE 312




/* Copy the first part of user declarations.  */
#line 24 "./parser.y"

#include <assert.h>
#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <errno.h>
#include "rename.h"
#include "util.h"

#define REF_IDENTS

#define do_binop(rv,op,a,b)		do {		\
	if (IDL_binop_chktypes (op, a, b))		\
		YYABORT;				\
	if (!(__IDL_flags & IDLF_NO_EVAL_CONST)) {	\
		rv = IDL_binop_eval (op, a, b);		\
		IDL_tree_free (a);			\
		IDL_tree_free (b);			\
		if (!rv) YYABORT;			\
	} else {					\
		rv = IDL_binop_new (op, a, b);		\
	}						\
} while (0)

#define do_unaryop(rv,op,a)		do {		\
	if (IDL_unaryop_chktypes (op, a))		\
		YYABORT;				\
	if (!(__IDL_flags & IDLF_NO_EVAL_CONST)) {	\
		rv = IDL_unaryop_eval (op, a);		\
		IDL_tree_free (a);			\
		if (!rv) YYABORT;			\
	} else {					\
		rv = IDL_unaryop_new (op, a);		\
	}						\
} while (0)

#define IS_INHIBIT_STATE()				\
	(__IDL_inhibits > 0 ||				\
	  ((__IDL_flags & IDLF_INHIBIT_INCLUDES) &&	\
	     (__IDL_flagsi & IDLFP_IN_INCLUDES) ) )


#define assign_declspec(tree,declspec)	do {		\
	IDL_NODE_DECLSPEC (tree) = declspec;		\
	if ( IS_INHIBIT_STATE() ) {			\
		IDL_NODE_DECLSPEC (tree) |=		\
			IDLF_DECLSPEC_EXIST |		\
			IDLF_DECLSPEC_INHIBIT;		\
	}						\
	if ( __IDL_pidl > 0 ) {				\
		IDL_NODE_DECLSPEC (tree) |=		\
			IDLF_DECLSPEC_PIDL;		\
	}						\
} while (0)

#define assign_props(tree,props)	do {		\
	if (__IDL_flags & IDLF_PROPERTIES)		\
		IDL_NODE_PROPERTIES (tree) = (props);	\
	else						\
		__IDL_free_properties (props);		\
} while (0)

extern int		yylex				(void);
static IDL_declspec_t	IDL_parse_declspec		(const char *strspec);
static int		IDL_binop_chktypes		(enum IDL_binop op,
							 IDL_tree a,
							 IDL_tree b);
static int		IDL_unaryop_chktypes		(enum IDL_unaryop op,
							 IDL_tree a);
static IDL_tree		IDL_binop_eval			(enum IDL_binop op,
							 IDL_tree a,
							 IDL_tree b);
static IDL_tree		IDL_unaryop_eval		(enum IDL_unaryop op,
							 IDL_tree a);
static IDL_tree		list_start			(IDL_tree a,
							 gboolean filter_null);
static IDL_tree		list_chain			(IDL_tree a,
							 IDL_tree b,
							 gboolean filter_null);
static IDL_tree		zlist_chain			(IDL_tree a,
							 IDL_tree b,
							 gboolean filter_null);
static int		do_token_error			(IDL_tree p,
							 const char *message,
							 gboolean prev);
static void		illegal_context_type_error	(IDL_tree p,
							 const char *what);
static void		illegal_type_error		(IDL_tree p,
							 const char *message);


/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 117 "./parser.y"
typedef union YYSTYPE {
	IDL_tree tree;
	struct {
		IDL_tree tree;
		gpointer data;
	} treedata;
	GHashTable *hash_table;
	char *str;
	gboolean boolean;
	IDL_declspec_t declspec;
	IDL_longlong_t integer;
	double floatp;
	enum IDL_unaryop unaryop;
	enum IDL_param_attr paramattr;
} YYSTYPE;
/* Line 191 of yacc.c.  */
#line 298 "y.tab.c"
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 214 of yacc.c.  */
#line 310 "y.tab.c"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  26
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   742

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  79
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  148
/* YYNRULES -- Number of rules. */
#define YYNRULES  278
/* YYNRULES -- Number of states. */
#define YYNSTATES  396

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   312

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,    73,    68,     2,
      63,    64,    71,    69,    59,    70,     2,    72,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    62,    58,
      75,    65,    76,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    77,     2,    78,    67,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    60,    66,    61,    74,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned short yyprhs[] =
{
       0,     0,     3,     4,     6,     7,     9,    11,    14,    16,
      17,    19,    21,    22,    24,    27,    30,    33,    36,    39,
      41,    43,    45,    47,    50,    51,    59,    61,    63,    65,
      66,    67,    80,    86,    87,    90,    92,    96,    98,    99,
     102,   105,   108,   111,   114,   117,   119,   121,   124,   128,
     130,   132,   134,   138,   139,   146,   149,   151,   153,   155,
     157,   159,   161,   163,   165,   166,   168,   169,   171,   172,
     173,   183,   184,   185,   199,   201,   203,   205,   207,   209,
     211,   213,   216,   220,   223,   225,   228,   232,   235,   238,
     244,   247,   254,   255,   258,   259,   261,   264,   265,   272,
     274,   276,   278,   280,   282,   284,   286,   288,   290,   292,
     293,   295,   298,   307,   308,   311,   313,   314,   316,   317,
     320,   325,   329,   331,   335,   336,   342,   344,   346,   348,
     350,   351,   353,   354,   356,   361,   366,   368,   370,   372,
     374,   376,   378,   380,   382,   384,   386,   388,   392,   394,
     398,   400,   404,   406,   410,   414,   416,   420,   424,   426,
     430,   434,   438,   441,   443,   445,   447,   449,   451,   453,
     457,   459,   461,   463,   465,   467,   469,   470,   478,   480,
     482,   485,   489,   491,   495,   497,   500,   504,   506,   508,
     510,   512,   514,   516,   518,   520,   522,   524,   526,   528,
     530,   537,   542,   544,   546,   549,   556,   558,   560,   562,
     564,   566,   568,   570,   572,   575,   577,   579,   581,   584,
     587,   591,   593,   595,   597,   599,   601,   603,   605,   610,
     612,   617,   619,   621,   625,   627,   629,   631,   633,   635,
     639,   642,   644,   647,   651,   654,   657,   662,   664,   668,
     670,   672,   674,   676,   677,   679,   681,   683,   685,   687,
     691,   693,   694,   696,   697,   698,   703,   705,   707,   709,
     711,   713,   715,   717,   720,   722,   724,   727,   729
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const short yyrhs[] =
{
      80,     0,    -1,    -1,    82,    -1,    -1,    82,    -1,    87,
      -1,    82,    87,    -1,    58,    -1,    -1,    58,    -1,    59,
      -1,    -1,   164,    -1,   100,    83,    -1,   122,    83,    -1,
     124,    83,    -1,    92,    83,    -1,    89,    83,    -1,   222,
      -1,   223,    -1,    86,    -1,    84,    -1,   213,    21,    -1,
      -1,    88,   205,    90,    60,    81,    61,   206,    -1,   205,
      -1,    23,    -1,    38,    -1,    -1,    -1,   213,   214,    19,
      91,    93,   206,    95,    94,    60,    97,    61,   206,    -1,
     213,   214,    19,    91,   206,    -1,    -1,    62,    96,    -1,
     164,    -1,    96,    85,   164,    -1,    98,    -1,    -1,    98,
      99,    -1,   100,    83,    -1,   124,    83,    -1,   135,    83,
      -1,   128,    83,    -1,   122,    83,    -1,   222,    -1,    84,
      -1,   213,   101,    -1,   214,    39,   103,    -1,   109,    -1,
     112,    -1,   162,    -1,   214,    22,   195,    -1,    -1,   214,
      22,   195,    63,   102,    51,    -1,   104,   193,    -1,   105,
      -1,   106,    -1,   169,    -1,   170,    -1,   164,    -1,   109,
      -1,   112,    -1,   162,    -1,    -1,   203,    -1,    -1,   204,
      -1,    -1,    -1,   214,    35,   110,   108,    60,   111,   167,
      61,   206,    -1,    -1,    -1,   214,    40,   113,   108,    36,
      63,   115,    64,    60,   114,   116,    61,   206,    -1,   175,
      -1,   184,    -1,   186,    -1,   162,    -1,   164,    -1,   117,
      -1,   118,    -1,   117,   118,    -1,   120,   119,    83,    -1,
     104,   194,    -1,   121,    -1,   120,   121,    -1,     6,   151,
      62,    -1,    10,    62,    -1,   213,   123,    -1,     8,   150,
     203,    65,   151,    -1,   213,   125,    -1,    13,   204,    60,
     126,    61,   206,    -1,    -1,   126,   168,    -1,    -1,    31,
      -1,   213,   129,    -1,    -1,   214,   127,     4,   130,   131,
     197,    -1,   133,    -1,    43,    -1,   171,    -1,   106,    -1,
     169,    -1,   191,    -1,   192,    -1,   173,    -1,   164,    -1,
     132,    -1,    -1,    25,    -1,   213,   136,    -1,   214,   134,
     137,   204,   141,   206,   146,   147,    -1,    -1,   138,   133,
      -1,    43,    -1,    -1,    42,    -1,    -1,    59,    42,    -1,
      63,   142,   140,    64,    -1,    63,   139,    64,    -1,   143,
      -1,   142,    85,   143,    -1,    -1,   214,   145,   144,   131,
     195,    -1,    17,    -1,    29,    -1,    18,    -1,   131,    -1,
      -1,   148,    -1,    -1,   149,    -1,    30,    63,    96,    64,
      -1,     9,    63,   211,    64,    -1,   175,    -1,   184,    -1,
     185,    -1,   186,    -1,   172,    -1,   191,    -1,   192,    -1,
     174,    -1,   164,    -1,   152,    -1,   153,    -1,   152,    66,
     153,    -1,   154,    -1,   153,    67,   154,    -1,   155,    -1,
     154,    68,   155,    -1,   156,    -1,   155,    28,   156,    -1,
     155,    27,   156,    -1,   157,    -1,   156,    69,   157,    -1,
     156,    70,   157,    -1,   158,    -1,   157,    71,   158,    -1,
     157,    72,   158,    -1,   157,    73,   158,    -1,   159,   160,
      -1,   160,    -1,    70,    -1,    69,    -1,    74,    -1,   164,
      -1,   161,    -1,    63,   151,    64,    -1,   216,    -1,   217,
      -1,   218,    -1,   219,    -1,   220,    -1,   221,    -1,    -1,
     214,    12,   163,   107,    60,   166,    61,    -1,   165,    -1,
     208,    -1,    26,   210,    -1,   165,    26,   202,    -1,   203,
      -1,   166,    85,   203,    -1,   168,    -1,   167,   168,    -1,
     104,   193,    83,    -1,   172,    -1,   175,    -1,   184,    -1,
     185,    -1,   186,    -1,   187,    -1,   188,    -1,   189,    -1,
     190,    -1,   171,    -1,   191,    -1,   192,    -1,   173,    -1,
      32,    75,   105,    59,   212,    76,    -1,    32,    75,   105,
      76,    -1,    16,    -1,    11,    -1,    20,    11,    -1,    15,
      75,   212,    59,   216,    76,    -1,    15,    -1,   176,    -1,
     180,    -1,   177,    -1,   178,    -1,   179,    -1,    33,    -1,
      20,    -1,    20,    20,    -1,   181,    -1,   182,    -1,   183,
      -1,    41,    33,    -1,    41,    20,    -1,    41,    20,    20,
      -1,     7,    -1,    44,    -1,     5,    -1,    24,    -1,     3,
      -1,    23,    -1,    38,    -1,    34,    75,   212,    76,    -1,
      34,    -1,    45,    75,   212,    76,    -1,    45,    -1,   194,
      -1,   193,    85,   194,    -1,   195,    -1,   196,    -1,   203,
      -1,   198,    -1,   195,    -1,   197,    85,   195,    -1,   203,
     199,    -1,   200,    -1,   199,   200,    -1,    77,   212,    78,
      -1,    77,    78,    -1,    49,    50,    -1,   201,    59,    49,
      50,    -1,    49,    -1,   201,    59,    49,    -1,    52,    -1,
     207,    -1,   207,    -1,   209,    -1,    -1,   202,    -1,   202,
      -1,   202,    -1,   202,    -1,   217,    -1,   211,    85,   217,
      -1,   151,    -1,    -1,    48,    -1,    -1,    -1,    77,   215,
     201,    78,    -1,    47,    -1,   224,    -1,   226,    -1,    55,
      -1,    46,    -1,    37,    -1,    14,    -1,   213,    56,    -1,
      57,    -1,   225,    -1,   224,   225,    -1,    54,    -1,    53,
      -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short yyrline[] =
{
       0,   309,   309,   310,   313,   314,   317,   318,   321,   322,
     328,   334,   335,   341,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   361,   365,   364,   402,   403,   407,   416,
     439,   413,   451,   464,   465,   511,   512,   516,   519,   520,
     523,   524,   525,   526,   527,   528,   529,   532,   538,   551,
     552,   553,   554,   560,   559,   575,   578,   579,   582,   583,
     584,   587,   588,   589,   592,   596,   599,   603,   607,   608,
     606,   622,   625,   621,   638,   639,   640,   641,   642,   645,
     648,   649,   652,   656,   670,   671,   674,   675,   678,   684,
     691,   697,   702,   703,   706,   707,   710,   719,   716,   735,
     736,   743,   744,   747,   748,   749,   750,   751,   752,   758,
     759,   762,   768,   780,   780,   782,   785,   786,   789,   790,
     793,   800,   806,   807,   813,   811,   821,   822,   823,   824,
     830,   831,   834,   835,   838,   843,   848,   849,   850,   851,
     852,   853,   854,   855,   856,   859,   862,   863,   866,   867,
     870,   871,   874,   875,   876,   879,   880,   881,   884,   885,
     886,   887,   890,   891,   894,   895,   896,   899,   913,   914,
     917,   918,   919,   920,   921,   922,   926,   925,   935,   943,
     944,   945,   971,   972,   976,   977,   980,   995,   996,   997,
     998,   999,  1000,  1001,  1002,  1003,  1006,  1007,  1008,  1009,
    1012,  1015,  1020,  1021,  1022,  1025,  1030,  1033,  1034,  1037,
    1038,  1039,  1042,  1045,  1048,  1051,  1052,  1053,  1056,  1059,
    1062,  1065,  1068,  1071,  1074,  1077,  1080,  1083,  1086,  1089,
    1092,  1095,  1098,  1099,  1103,  1104,  1107,  1110,  1113,  1114,
    1118,  1133,  1134,  1138,  1139,  1142,  1147,  1153,  1157,  1164,
    1167,  1175,  1188,  1205,  1217,  1255,  1274,  1304,  1323,  1324,
    1328,  1367,  1368,  1374,  1375,  1375,  1387,  1390,  1393,  1396,
    1399,  1402,  1403,  1406,  1412,  1417,  1418,  1426,  1433
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "TOK_ANY", "TOK_ATTRIBUTE", "TOK_BOOLEAN", 
  "TOK_CASE", "TOK_CHAR", "TOK_CONST", "TOK_CONTEXT", "TOK_DEFAULT", 
  "TOK_DOUBLE", "TOK_ENUM", "TOK_EXCEPTION", "TOK_FALSE", "TOK_FIXED", 
  "TOK_FLOAT", "TOK_IN", "TOK_INOUT", "TOK_INTERFACE", "TOK_LONG", 
  "TOK_MODULE", "TOK_NATIVE", "TOK_OBJECT", "TOK_OCTET", "TOK_ONEWAY", 
  "TOK_OP_SCOPE", "TOK_OP_SHL", "TOK_OP_SHR", "TOK_OUT", "TOK_RAISES", 
  "TOK_READONLY", "TOK_SEQUENCE", "TOK_SHORT", "TOK_STRING", "TOK_STRUCT", 
  "TOK_SWITCH", "TOK_TRUE", "TOK_TYPECODE", "TOK_TYPEDEF", "TOK_UNION", 
  "TOK_UNSIGNED", "TOK_VARARGS", "TOK_VOID", "TOK_WCHAR", "TOK_WSTRING", 
  "TOK_FLOATP", "TOK_INTEGER", "TOK_DECLSPEC", "TOK_PROP_KEY", 
  "TOK_PROP_VALUE", "TOK_NATIVE_TYPE", "TOK_IDENT", "TOK_SQSTRING", 
  "TOK_DQSTRING", "TOK_FIXEDP", "TOK_CODEFRAG", "TOK_SRCFILE", "';'", 
  "','", "'{'", "'}'", "':'", "'('", "')'", "'='", "'|'", "'^'", "'&'", 
  "'+'", "'-'", "'*'", "'/'", "'%'", "'~'", "'<'", "'>'", "'['", "']'", 
  "$accept", "specification", "z_definition_list", "definition_list", 
  "check_semicolon", "useless_semicolon", "check_comma", "illegal_ident", 
  "definition", "module_declspec", "module", "@1", 
  "interface_catch_ident", "interface", "@2", "@3", "z_inheritance", 
  "scoped_name_list", "interface_body", "export_list", "export", 
  "type_dcl", "type_dcl_def", "@4", "type_declarator", "type_spec", 
  "simple_type_spec", "constr_type_spec", "z_new_ident_catch", 
  "z_new_scope_catch", "struct_type", "@5", "@6", "union_type", "@7", 
  "@8", "switch_type_spec", "switch_body", "case_stmt_list", "case_stmt", 
  "element_spec", "case_label_list", "case_label", "const_dcl", 
  "const_dcl_def", "except_dcl", "except_dcl_def", "member_zlist", 
  "is_readonly", "attr_dcl", "attr_dcl_def", "@9", "param_type_spec", 
  "op_param_type_spec_illegal", "op_param_type_spec", "is_oneway", 
  "op_dcl", "op_dcl_def", "op_type_spec", "@10", "is_varargs", 
  "is_cvarargs", "parameter_dcls", "param_dcl_list", "param_dcl", "@11", 
  "param_attribute", "is_raises_expr", "is_context_expr", "raises_expr", 
  "context_expr", "const_type", "const_exp", "or_expr", "xor_expr", 
  "and_expr", "shift_expr", "add_expr", "mult_expr", "unary_expr", 
  "unary_op", "primary_expr", "literal", "enum_type", "@12", 
  "scoped_name", "ns_scoped_name", "enumerator_list", "member_list", 
  "member", "base_type_spec", "template_type_spec", "sequence_type", 
  "floating_pt_type", "fixed_pt_type", "fixed_pt_const_type", 
  "integer_type", "signed_int", "signed_short_int", "signed_long_int", 
  "signed_longlong_int", "unsigned_int", "unsigned_short_int", 
  "unsigned_long_int", "unsigned_longlong_int", "char_type", 
  "wide_char_type", "boolean_type", "octet_type", "any_type", 
  "object_type", "typecode_type", "string_type", "wide_string_type", 
  "declarator_list", "declarator", "simple_declarator", 
  "complex_declarator", "simple_declarator_list", "array_declarator", 
  "fixed_array_size_list", "fixed_array_size", "prop_hash", "ident", 
  "new_ident", "new_scope", "new_or_prev_scope", "pop_scope", 
  "ns_new_ident", "ns_prev_ident", "cur_ns_new_or_prev_ident", 
  "ns_global_ident", "string_lit_list", "positive_int_const", 
  "z_declspec", "z_props", "@13", "integer_lit", "string_lit", "char_lit", 
  "fixed_pt_lit", "floating_pt_lit", "boolean_lit", "codefrag", "srcfile", 
  "dqstring_cat", "dqstring", "sqstring", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,    59,    44,
     123,   125,    58,    40,    41,    61,   124,    94,    38,    43,
      45,    42,    47,    37,   126,    60,    62,    91,    93
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    79,    80,    80,    81,    81,    82,    82,    83,    83,
      84,    85,    85,    86,    87,    87,    87,    87,    87,    87,
      87,    87,    87,    88,    90,    89,    91,    91,    91,    93,
      94,    92,    92,    95,    95,    96,    96,    97,    98,    98,
      99,    99,    99,    99,    99,    99,    99,   100,   101,   101,
     101,   101,   101,   102,   101,   103,   104,   104,   105,   105,
     105,   106,   106,   106,   107,   107,   108,   108,   110,   111,
     109,   113,   114,   112,   115,   115,   115,   115,   115,   116,
     117,   117,   118,   119,   120,   120,   121,   121,   122,   123,
     124,   125,   126,   126,   127,   127,   128,   130,   129,   131,
     131,   132,   132,   133,   133,   133,   133,   133,   133,   134,
     134,   135,   136,   138,   137,   137,   139,   139,   140,   140,
     141,   141,   142,   142,   144,   143,   145,   145,   145,   145,
     146,   146,   147,   147,   148,   149,   150,   150,   150,   150,
     150,   150,   150,   150,   150,   151,   152,   152,   153,   153,
     154,   154,   155,   155,   155,   156,   156,   156,   157,   157,
     157,   157,   158,   158,   159,   159,   159,   160,   160,   160,
     161,   161,   161,   161,   161,   161,   163,   162,   164,   165,
     165,   165,   166,   166,   167,   167,   168,   169,   169,   169,
     169,   169,   169,   169,   169,   169,   170,   170,   170,   170,
     171,   171,   172,   172,   172,   173,   174,   175,   175,   176,
     176,   176,   177,   178,   179,   180,   180,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   191,
     192,   192,   193,   193,   194,   194,   195,   196,   197,   197,
     198,   199,   199,   200,   200,   201,   201,   201,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   211,
     212,   213,   213,   214,   215,   214,   216,   217,   218,   219,
     220,   221,   221,   222,   223,   224,   224,   225,   226
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     0,     1,     0,     1,     1,     2,     1,     0,
       1,     1,     0,     1,     2,     2,     2,     2,     2,     1,
       1,     1,     1,     2,     0,     7,     1,     1,     1,     0,
       0,    12,     5,     0,     2,     1,     3,     1,     0,     2,
       2,     2,     2,     2,     2,     1,     1,     2,     3,     1,
       1,     1,     3,     0,     6,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     0,     1,     0,     1,     0,     0,
       9,     0,     0,    13,     1,     1,     1,     1,     1,     1,
       1,     2,     3,     2,     1,     2,     3,     2,     2,     5,
       2,     6,     0,     2,     0,     1,     2,     0,     6,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     0,
       1,     2,     8,     0,     2,     1,     0,     1,     0,     2,
       4,     3,     1,     3,     0,     5,     1,     1,     1,     1,
       0,     1,     0,     1,     4,     4,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     3,     1,     3,
       1,     3,     1,     3,     3,     1,     3,     3,     1,     3,
       3,     3,     2,     1,     1,     1,     1,     1,     1,     3,
       1,     1,     1,     1,     1,     1,     0,     7,     1,     1,
       2,     3,     1,     3,     1,     2,     3,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       6,     4,     1,     1,     2,     6,     1,     1,     1,     1,
       1,     1,     1,     1,     2,     1,     1,     1,     2,     2,
       3,     1,     1,     1,     1,     1,     1,     1,     4,     1,
       4,     1,     1,     3,     1,     1,     1,     1,     1,     3,
       2,     1,     2,     3,     2,     2,     4,     1,     3,     1,
       1,     1,     1,     0,     1,     1,     1,     1,     1,     3,
       1,     0,     1,     0,     0,     4,     1,     1,     1,     1,
       1,     1,     1,     2,     1,     1,     2,     1,     1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned short yydefact[] =
{
     261,     0,   262,   249,   274,    10,     0,   261,    22,    21,
       6,     0,     9,     9,     9,     9,     9,    13,   178,   255,
     179,   263,    19,    20,   257,   180,     1,     7,   256,    24,
     252,     8,    18,    17,    14,    15,    16,     0,     0,     0,
      23,   273,   264,    47,    49,    50,    88,    90,    51,     0,
       0,   181,   223,   221,   203,   206,   202,   213,   212,   229,
       0,   222,   231,     0,   144,   140,   143,   136,   207,   209,
     210,   211,   208,   215,   216,   217,   137,   138,   139,   141,
     142,   254,     0,   251,     0,   176,     0,     0,    68,   263,
      71,   261,   204,   214,     0,   219,   218,     0,     0,   250,
      92,   247,     0,    64,    27,    28,   253,    26,    52,   236,
      66,   225,     0,   226,   224,     0,   227,    48,     0,    56,
      57,    61,    62,    63,    60,    58,    59,   196,   187,   199,
     188,   189,   190,   191,   192,   193,   194,   195,   197,   198,
       0,    66,     0,   261,   272,   271,   270,   266,   278,   277,
     269,     0,   165,   164,   166,   260,   145,   146,   148,   150,
     152,   155,   158,     0,   163,   168,   167,     0,   170,   171,
     172,   173,   174,   175,   267,   275,   268,   220,     0,     0,
     263,   245,     0,   265,     0,    65,   253,    32,    53,     0,
      67,     0,     0,    55,   232,   234,   235,   237,   236,     0,
     253,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   162,   228,   276,   230,    89,   253,     0,    93,
     248,     0,    33,     0,    69,     0,     0,    11,     0,     0,
     240,   241,     0,    25,   169,   147,   149,   151,   154,   153,
     156,   157,   159,   160,   161,    91,     9,   246,    12,   182,
       0,    30,    54,   263,     0,     0,   201,   233,   244,     0,
     242,   263,   186,   177,     0,    12,    35,     0,   263,   184,
       0,     0,   243,   213,     0,    77,    78,    74,    75,    76,
       0,   183,     0,    38,   253,   185,   205,   200,     0,    36,
       0,   261,    70,    72,   253,    46,    39,     9,     9,     9,
       9,     9,   263,    45,     0,    31,    40,    44,    41,    43,
      42,    96,   111,   109,     0,     0,     0,    79,    80,   263,
      84,   110,    95,     0,   113,     0,    87,   253,    81,     0,
       9,    85,    97,   115,     0,   263,    86,    73,    83,    82,
     263,     0,   102,   108,   114,   107,   103,   101,   106,   104,
     105,   100,     0,    99,   263,   253,   238,    98,   117,     0,
      12,   122,   263,   130,     0,   121,    11,   263,     0,   126,
     128,   127,   129,   124,     0,   132,   131,   239,   119,   123,
     120,   263,     0,     0,   112,   133,     0,    12,     0,   125,
     134,    12,   258,   135,     0,   259
};

/* YYDEFGOTO[NTERM-NUM]. */
static const short yydefgoto[] =
{
      -1,     6,   142,     7,    32,     8,   228,     9,    10,    11,
      12,    50,   106,    13,   186,   267,   251,   265,   290,   291,
     296,    14,    43,   223,   117,   218,   119,   120,   184,   189,
     121,   110,   253,   122,   141,   304,   274,   316,   317,   318,
     330,   319,   320,    15,    46,    16,    47,   180,   323,   300,
     311,   340,   352,   343,   353,   324,   301,   312,   334,   335,
     359,   368,   355,   360,   361,   381,   373,   375,   384,   376,
     385,    63,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,   123,   103,   166,    18,   248,   268,   219,
     125,   126,   127,   128,   129,    66,   130,    68,    69,    70,
      71,    72,    73,    74,    75,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   193,   194,   195,   196,   357,   197,
     230,   231,   102,    19,   109,   190,    29,   187,    99,    20,
      30,    25,   391,   167,    21,   140,    84,   168,   169,   170,
     171,   172,   173,    22,    23,   174,   175,   176
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -365
static const short yypact[] =
{
      84,   -10,  -365,  -365,  -365,  -365,    58,   151,  -365,  -365,
    -365,   -10,    39,    39,    39,    39,    39,  -365,    45,  -365,
    -365,    27,  -365,  -365,  -365,  -365,  -365,  -365,  -365,  -365,
    -365,  -365,  -365,  -365,  -365,  -365,  -365,   -10,   690,   -10,
    -365,  -365,  -365,  -365,  -365,  -365,  -365,  -365,  -365,   235,
      40,  -365,  -365,  -365,  -365,  -365,  -365,    71,  -365,    38,
      31,  -365,    64,   -10,  -365,  -365,  -365,  -365,  -365,  -365,
    -365,  -365,  -365,  -365,  -365,  -365,  -365,  -365,  -365,  -365,
    -365,  -365,    83,  -365,    97,  -365,    18,   -10,  -365,   609,
    -365,   204,  -365,  -365,   121,   140,  -365,   121,   105,  -365,
    -365,   136,   -34,   -10,  -365,  -365,    63,  -365,   126,  -365,
     -10,  -365,   117,  -365,  -365,   119,  -365,  -365,   -10,  -365,
    -365,  -365,  -365,  -365,  -365,  -365,  -365,  -365,  -365,  -365,
    -365,  -365,  -365,  -365,  -365,  -365,  -365,  -365,  -365,  -365,
      33,   -10,   135,   220,  -365,  -365,  -365,  -365,  -365,  -365,
    -365,   121,  -365,  -365,  -365,  -365,   132,   144,   146,   153,
     137,   129,  -365,   179,  -365,  -365,  -365,   128,  -365,  -365,
    -365,  -365,  -365,  -365,   169,  -365,  -365,  -365,   148,   121,
     467,  -365,   188,  -365,   168,  -365,  -365,  -365,  -365,   185,
    -365,   121,   655,    22,  -365,  -365,  -365,  -365,   171,   213,
    -365,   186,   121,   121,   121,   121,   121,   121,   121,   121,
     121,   121,  -365,  -365,  -365,  -365,  -365,  -365,   -10,  -365,
     201,   -10,   191,   209,  -365,   205,    17,  -365,   -10,    75,
     171,  -365,   206,  -365,  -365,   144,   146,   153,   137,   137,
     129,   129,  -365,  -365,  -365,  -365,   154,  -365,    95,  -365,
      11,  -365,  -365,   609,   224,   121,  -365,  -365,  -365,   198,
    -365,    26,  -365,  -365,   -10,   159,  -365,   223,   515,  -365,
     208,   210,  -365,   270,   227,  -365,  -365,  -365,  -365,  -365,
     280,  -365,    11,  -365,  -365,  -365,  -365,  -365,   233,  -365,
     234,    47,  -365,  -365,  -365,  -365,  -365,    39,    39,    39,
      39,    39,    42,  -365,   127,  -365,  -365,  -365,  -365,  -365,
    -365,  -365,  -365,   313,   121,   232,   236,   127,  -365,   421,
    -365,  -365,  -365,   292,   255,   237,  -365,  -365,  -365,   -10,
      39,  -365,  -365,  -365,   -10,   609,  -365,  -365,  -365,  -365,
     563,   239,  -365,  -365,  -365,  -365,  -365,  -365,  -365,  -365,
    -365,  -365,   -10,  -365,    15,  -365,  -365,    22,  -365,   243,
      56,  -365,   373,   279,   -10,  -365,   273,   241,   252,  -365,
    -365,  -365,  -365,  -365,   256,   311,  -365,  -365,  -365,  -365,
    -365,   563,    11,   258,  -365,  -365,   -10,    91,   169,  -365,
    -365,   107,  -365,  -365,   169,  -365
};

/* YYPGOTO[NTERM-NUM].  */
static const short yypgoto[] =
{
    -365,  -365,  -365,   231,    13,    32,  -226,  -365,    14,  -365,
    -365,  -365,  -365,  -365,  -365,  -365,  -365,   -56,  -365,  -365,
    -365,    41,  -365,  -365,  -365,   -76,   139,  -275,  -365,   195,
     -14,  -365,  -365,   -13,  -365,  -365,  -365,  -365,  -365,    12,
    -365,  -365,    20,    46,  -365,    50,  -365,  -365,  -365,  -365,
    -365,  -365,  -328,  -365,     7,  -365,  -365,  -365,  -365,  -365,
    -365,  -365,  -365,  -365,   -12,  -365,  -365,  -365,  -365,  -365,
    -365,  -365,  -132,  -365,   152,   147,   155,    16,    28,   -47,
    -365,   193,  -365,   -17,  -365,     5,  -365,  -365,  -365,  -178,
    -274,  -365,  -263,   319,  -152,  -365,   -23,  -365,  -365,  -365,
    -365,  -365,  -365,  -365,  -365,   -22,   320,   -21,  -365,  -365,
    -365,  -365,   -35,   -32,   142,  -205,   -85,  -365,  -365,  -365,
    -365,   131,  -365,    -1,   -49,   -28,   276,  -168,   -30,  -365,
    -365,  -365,  -365,   -77,    73,   -20,  -365,   111,  -364,  -365,
    -365,  -365,  -365,    77,  -365,  -365,   192,  -365
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -119
static const short yytable[] =
{
      24,    49,   108,    79,    48,    17,    80,    44,    45,    83,
      28,    82,    17,   118,    98,    67,    76,    78,   222,   201,
     178,    27,   264,   257,   392,   182,    33,    34,    35,    36,
     395,    52,   233,    53,   372,    38,    51,     1,    81,   282,
      39,   104,     3,    64,   183,    85,   273,   216,    40,   245,
      38,    95,     1,   386,   185,    39,   105,   358,    26,    58,
     342,   346,    81,     3,    96,   342,   346,    60,    88,   198,
       3,    37,   347,    90,   -12,   269,   255,   347,     3,  -116,
      83,   227,    92,    41,    -2,    28,    81,   342,   346,   144,
     285,    93,    42,   256,   124,     2,    17,    31,    41,   347,
      91,     1,    81,    42,    42,     5,   342,   346,   -37,    81,
       1,    83,   145,    94,   225,   366,   292,    81,   347,    42,
    -118,   146,   147,   -29,   338,   -29,   305,     3,   148,   149,
     150,   364,     2,   314,   367,   144,     3,   315,   151,    97,
      81,     4,     5,   100,   152,   153,   101,     1,    17,   154,
     227,    -3,   259,   258,   227,   390,   263,    27,   145,   337,
     177,   282,   242,   243,   244,   394,   227,   146,   147,   198,
     179,   393,   249,     3,   148,   149,   150,     1,   271,   198,
     205,   206,   325,   348,   151,   124,   181,   363,   348,   188,
     152,   153,   191,   144,   192,   154,   200,   124,   202,     2,
     209,   210,   211,     3,   213,     1,   207,   208,     4,     5,
     348,   203,    31,   227,   204,   281,   145,    81,   227,   -34,
      81,   238,   239,   149,   215,   146,   147,    81,   221,   348,
       1,     3,   148,   149,   150,   240,   241,   220,   277,   278,
     279,   280,   151,   329,   275,   224,     1,    85,   229,   232,
     234,   247,     2,   250,    86,   266,     3,    87,   124,   262,
     252,     4,     5,    81,   254,    -4,   276,   356,     2,   261,
      88,   147,     3,   124,    89,    90,   272,     4,     5,   377,
     198,    -5,   313,   283,   286,    48,   287,   289,    44,    45,
      93,   288,    85,   293,   326,   294,   332,   327,   333,   336,
     349,   389,   354,   350,    83,   349,   341,   365,   350,   374,
     306,   307,   308,   309,   310,   378,   380,   -94,    42,   382,
     383,   388,   143,   295,   124,    85,   387,   349,    81,   328,
     350,   226,   297,    81,   362,    87,   199,   298,   321,   331,
     345,   299,   344,   339,   322,   345,   349,   362,    88,   350,
     236,    81,    89,    90,   235,   379,   212,    65,    77,   237,
     246,   260,   107,    81,   302,   270,   214,   345,   303,     0,
       0,     0,     0,     0,     0,     0,   111,     0,    52,     0,
      53,     0,     0,     0,    54,    81,   345,   266,   112,    56,
     369,   370,     0,    57,     0,     0,   113,   114,     0,     1,
       0,     0,   371,     0,     0,   115,    58,    59,     0,     0,
       0,   116,     0,     0,    60,     0,   351,    61,    62,     0,
       0,     0,     0,     0,   111,     3,    52,   314,    53,     0,
       0,   315,    54,     0,     0,     0,   112,    56,     0,     0,
       0,    57,     0,     0,   113,   114,     0,     1,     0,     0,
      42,     0,     0,   115,    58,    59,     0,     0,     0,   116,
       0,     0,    60,     0,     0,    61,    62,     0,     0,     0,
     111,     0,    52,     3,    53,     0,     0,     0,    54,     0,
       0,     0,   112,    56,     0,     0,     0,    57,     0,     0,
     113,   114,     0,     1,     0,     0,     0,     0,    42,   115,
      58,    59,     0,     0,     0,   116,     0,     0,    60,     0,
       0,    61,    62,     0,     0,     0,     0,     0,   111,     3,
      52,     0,    53,     0,     0,     0,    54,     0,   217,     0,
     112,    56,     0,     0,     0,    57,     0,     0,   113,   114,
       0,     1,     0,     0,    42,     0,     0,   115,    58,    59,
       0,     0,     0,   116,     0,     0,    60,     0,     0,    61,
      62,     0,     0,     0,     0,     0,   111,     3,    52,     0,
      53,     0,     0,     0,    54,     0,   284,     0,   112,    56,
       0,     0,     0,    57,     0,     0,   113,   114,     0,     1,
       0,     0,    42,     0,     0,   115,    58,    59,     0,     0,
       0,   116,     0,     0,    60,     0,   351,    61,    62,     0,
       0,     0,   111,     0,    52,     3,    53,     0,     0,     0,
      54,     0,     0,     0,   112,    56,     0,     0,     0,    57,
       0,     0,   113,   114,     0,     1,     0,     0,     0,     0,
      42,   115,    58,    59,     0,     0,     0,   116,     0,     0,
      60,     0,     0,    61,    62,     0,     0,     0,   111,     0,
      52,     3,    53,     0,     0,     0,    54,     0,     0,     0,
     112,    56,     0,     0,     0,    57,     0,     0,   113,   114,
       0,     1,     0,     0,     0,     0,    42,   115,    58,    59,
       0,     0,     0,   116,     0,    52,    60,    53,     0,    61,
      62,    54,     0,     0,     0,    55,    56,     3,     0,     0,
      57,     0,     0,     0,     0,     0,     1,     0,     0,     0,
       0,     0,     0,    58,    59,     0,     0,     0,     0,     0,
       0,    60,     0,     0,    61,    62,     0,     0,     0,     0,
       0,     0,     3
};

static const short yycheck[] =
{
       1,    21,    87,    38,    21,     0,    38,    21,    21,    39,
      11,    39,     7,    89,    63,    38,    38,    38,   186,   151,
      97,     7,   248,   228,   388,    59,    13,    14,    15,    16,
     394,     5,   200,     7,   362,     8,    37,    26,    39,   265,
      13,    23,    52,    38,    78,    12,    20,   179,    21,   217,
       8,    20,    26,   381,   103,    13,    38,    42,     0,    33,
     335,   335,    63,    52,    33,   340,   340,    41,    35,   118,
      52,    26,   335,    40,    52,   253,    59,   340,    52,    64,
     110,    59,    11,    56,     0,    86,    87,   362,   362,    14,
     268,    20,    77,    76,    89,    48,    91,    58,    56,   362,
      60,    26,   103,    77,    77,    58,   381,   381,    61,   110,
      26,   141,    37,    75,   191,    59,   284,   118,   381,    77,
      64,    46,    47,    60,   329,    62,   294,    52,    53,    54,
      55,   357,    48,     6,   360,    14,    52,    10,    63,    75,
     141,    57,    58,    60,    69,    70,    49,    26,   143,    74,
      59,     0,   229,    78,    59,    64,    61,   143,    37,   327,
      20,   387,   209,   210,   211,   391,    59,    46,    47,   218,
      65,    64,   221,    52,    53,    54,    55,    26,   255,   228,
      27,    28,   314,   335,    63,   180,    50,   355,   340,    63,
      69,    70,    75,    14,    75,    74,    61,   192,    66,    48,
      71,    72,    73,    52,    76,    26,    69,    70,    57,    58,
     362,    67,    58,    59,    68,   264,    37,   218,    59,    60,
     221,   205,   206,    54,    76,    46,    47,   228,    60,   381,
      26,    52,    53,    54,    55,   207,   208,    49,   261,   261,
     261,   261,    63,   319,   261,    60,    26,    12,    77,    36,
      64,    50,    48,    62,    19,   250,    52,    22,   253,   246,
      51,    57,    58,   264,    59,    61,   261,   352,    48,    63,
      35,    47,    52,   268,    39,    40,    78,    57,    58,   364,
     329,    61,   302,    60,    76,   302,    76,   282,   302,   302,
      20,    64,    12,    60,    62,    61,     4,    61,    43,    62,
     335,   386,    63,   335,   334,   340,   334,    64,   340,    30,
     297,   298,   299,   300,   301,    42,    64,     4,    77,    63,
       9,    63,    91,   291,   319,    12,   382,   362,   329,   317,
     362,   192,   291,   334,   354,    22,   141,   291,    25,   319,
     335,   291,   335,   330,    31,   340,   381,   367,    35,   381,
     203,   352,    39,    40,   202,   367,   163,    38,    38,   204,
     218,   230,    86,   364,   291,   254,   174,   362,   291,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,     5,    -1,
       7,    -1,    -1,    -1,    11,   386,   381,   382,    15,    16,
      17,    18,    -1,    20,    -1,    -1,    23,    24,    -1,    26,
      -1,    -1,    29,    -1,    -1,    32,    33,    34,    -1,    -1,
      -1,    38,    -1,    -1,    41,    -1,    43,    44,    45,    -1,
      -1,    -1,    -1,    -1,     3,    52,     5,     6,     7,    -1,
      -1,    10,    11,    -1,    -1,    -1,    15,    16,    -1,    -1,
      -1,    20,    -1,    -1,    23,    24,    -1,    26,    -1,    -1,
      77,    -1,    -1,    32,    33,    34,    -1,    -1,    -1,    38,
      -1,    -1,    41,    -1,    -1,    44,    45,    -1,    -1,    -1,
       3,    -1,     5,    52,     7,    -1,    -1,    -1,    11,    -1,
      -1,    -1,    15,    16,    -1,    -1,    -1,    20,    -1,    -1,
      23,    24,    -1,    26,    -1,    -1,    -1,    -1,    77,    32,
      33,    34,    -1,    -1,    -1,    38,    -1,    -1,    41,    -1,
      -1,    44,    45,    -1,    -1,    -1,    -1,    -1,     3,    52,
       5,    -1,     7,    -1,    -1,    -1,    11,    -1,    61,    -1,
      15,    16,    -1,    -1,    -1,    20,    -1,    -1,    23,    24,
      -1,    26,    -1,    -1,    77,    -1,    -1,    32,    33,    34,
      -1,    -1,    -1,    38,    -1,    -1,    41,    -1,    -1,    44,
      45,    -1,    -1,    -1,    -1,    -1,     3,    52,     5,    -1,
       7,    -1,    -1,    -1,    11,    -1,    61,    -1,    15,    16,
      -1,    -1,    -1,    20,    -1,    -1,    23,    24,    -1,    26,
      -1,    -1,    77,    -1,    -1,    32,    33,    34,    -1,    -1,
      -1,    38,    -1,    -1,    41,    -1,    43,    44,    45,    -1,
      -1,    -1,     3,    -1,     5,    52,     7,    -1,    -1,    -1,
      11,    -1,    -1,    -1,    15,    16,    -1,    -1,    -1,    20,
      -1,    -1,    23,    24,    -1,    26,    -1,    -1,    -1,    -1,
      77,    32,    33,    34,    -1,    -1,    -1,    38,    -1,    -1,
      41,    -1,    -1,    44,    45,    -1,    -1,    -1,     3,    -1,
       5,    52,     7,    -1,    -1,    -1,    11,    -1,    -1,    -1,
      15,    16,    -1,    -1,    -1,    20,    -1,    -1,    23,    24,
      -1,    26,    -1,    -1,    -1,    -1,    77,    32,    33,    34,
      -1,    -1,    -1,    38,    -1,     5,    41,     7,    -1,    44,
      45,    11,    -1,    -1,    -1,    15,    16,    52,    -1,    -1,
      20,    -1,    -1,    -1,    -1,    -1,    26,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    -1,    -1,    -1,    -1,
      -1,    41,    -1,    -1,    44,    45,    -1,    -1,    -1,    -1,
      -1,    -1,    52
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,    26,    48,    52,    57,    58,    80,    82,    84,    86,
      87,    88,    89,    92,   100,   122,   124,   164,   165,   202,
     208,   213,   222,   223,   202,   210,     0,    87,   202,   205,
     209,    58,    83,    83,    83,    83,    83,    26,     8,    13,
      21,    56,    77,   101,   109,   112,   123,   125,   162,   214,
      90,   202,     5,     7,    11,    15,    16,    20,    33,    34,
      41,    44,    45,   150,   164,   172,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   191,
     192,   202,   204,   207,   215,    12,    19,    22,    35,    39,
      40,    60,    11,    20,    75,    20,    33,    75,   203,   207,
      60,    49,   201,   163,    23,    38,    91,   205,   195,   203,
     110,     3,    15,    23,    24,    32,    38,   103,   104,   105,
     106,   109,   112,   162,   164,   169,   170,   171,   172,   173,
     175,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     214,   113,    81,    82,    14,    37,    46,    47,    53,    54,
      55,    63,    69,    70,    74,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   164,   212,   216,   217,
     218,   219,   220,   221,   224,   225,   226,    20,   212,    65,
     126,    50,    59,    78,   107,   203,    93,   206,    63,   108,
     204,    75,    75,   193,   194,   195,   196,   198,   203,   108,
      61,   151,    66,    67,    68,    27,    28,    69,    70,    71,
      72,    73,   160,    76,   225,    76,   151,    61,   104,   168,
      49,    60,   206,   102,    60,   212,   105,    59,    85,    77,
     199,   200,    36,   206,    64,   153,   154,   155,   156,   156,
     157,   157,   158,   158,   158,   206,   193,    50,   166,   203,
      62,    95,    51,   111,    59,    59,    76,   194,    78,   212,
     200,    63,    83,    61,    85,    96,   164,    94,   167,   168,
     216,   212,    78,    20,   115,   162,   164,   175,   184,   186,
     214,   203,    85,    60,    61,   168,    76,    76,    64,   164,
      97,    98,   206,    60,    61,    84,    99,   100,   122,   124,
     128,   135,   213,   222,   114,   206,    83,    83,    83,    83,
      83,   129,   136,   214,     6,    10,   116,   117,   118,   120,
     121,    25,    31,   127,   134,   151,    62,    61,   118,   104,
     119,   121,     4,    43,   137,   138,    62,   206,   194,    83,
     130,   204,   106,   132,   133,   164,   169,   171,   173,   191,
     192,    43,   131,   133,    63,   141,   195,   197,    42,   139,
     142,   143,   214,   206,    85,    64,    59,    85,   140,    17,
      18,    29,   131,   145,    30,   146,   148,   195,    42,   143,
      64,   144,    63,     9,   147,   149,   131,    96,    63,   195,
      64,   211,   217,    64,    85,   217
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrlab1

/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)         \
  Current.first_line   = Rhs[1].first_line;      \
  Current.first_column = Rhs[1].first_column;    \
  Current.last_line    = Rhs[N].last_line;       \
  Current.last_column  = Rhs[N].last_column;
#endif

/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YYDSYMPRINT(Args)			\
do {						\
  if (yydebug)					\
    yysymprint Args;				\
} while (0)

# define YYDSYMPRINTF(Title, Token, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr, 					\
                  Token, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (cinluded).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short *bottom, short *top)
#else
static void
yy_stack_print (bottom, top)
    short *bottom;
    short *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned int yylineno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
             yyrule - 1, yylineno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname [yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname [yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YYDSYMPRINT(Args)
# define YYDSYMPRINTF(Title, Token, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    {
      YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
# ifdef YYPRINT
      YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
    }
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yytype, yyvaluep)
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YYDSYMPRINTF ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %s, ", yytname[yytoken]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 309 "./parser.y"
    { yyerror ("Empty file"); YYABORT; }
    break;

  case 3:
#line 310 "./parser.y"
    { __IDL_root = yyvsp[0].tree; }
    break;

  case 4:
#line 313 "./parser.y"
    { yyval.tree = NULL; }
    break;

  case 6:
#line 317 "./parser.y"
    { yyval.tree = list_start (yyvsp[0].tree, TRUE); }
    break;

  case 7:
#line 318 "./parser.y"
    { yyval.tree = list_chain (yyvsp[-1].tree, yyvsp[0].tree, TRUE); }
    break;

  case 9:
#line 322 "./parser.y"
    {
	if (do_token_error (yyvsp[0].tree, "Missing semicolon after", TRUE))
		YYABORT;
}
    break;

  case 10:
#line 328 "./parser.y"
    {
	yyerror ("Dangling semicolon has no effect");
	yyval.tree = NULL;
}
    break;

  case 12:
#line 335 "./parser.y"
    {
	if (do_token_error (yyvsp[0].tree, "Missing comma after", TRUE))
		YYABORT;
}
    break;

  case 13:
#line 341 "./parser.y"
    {
	if (IDL_NODE_UP (yyvsp[0].tree))
		do_token_error (IDL_NODE_UP (yyvsp[0].tree), "Illegal context for", FALSE);
	else
		yyerror ("Illegal context for identifier");
	YYABORT;
}
    break;

  case 24:
#line 365 "./parser.y"
    {
	if (IDL_NODE_UP (yyvsp[0].tree) != NULL &&
	    IDL_NODE_TYPE (IDL_NODE_UP (yyvsp[0].tree)) != IDLN_MODULE) {
		yyerror ("Module definition conflicts");
		do_token_error (IDL_NODE_UP (yyvsp[0].tree), "with", FALSE);
		YYABORT;
	}
}
    break;

  case 25:
#line 374 "./parser.y"
    {
	IDL_tree module;

	if (yyvsp[-2].tree == NULL) {
		yyerrorv ("Empty module declaration `%s' is not legal IDL",
			  IDL_IDENT (yyvsp[-5].tree).str);
		module = NULL;
	}

	if (__IDL_flags & IDLF_COMBINE_REOPENED_MODULES) {
		if (IDL_NODE_UP (yyvsp[-5].tree) == NULL)
			module = IDL_module_new (yyvsp[-5].tree, yyvsp[-2].tree);
		else {
			module = IDL_NODE_UP (yyvsp[-5].tree);
			IDL_MODULE (module).definition_list =
				IDL_list_concat (IDL_MODULE (module).definition_list, yyvsp[-2].tree);
			module = NULL;
		}
	} else
		module = IDL_module_new (yyvsp[-5].tree, yyvsp[-2].tree);

	yyval.tree = module;
	if (yyval.tree) assign_declspec (yyval.tree, yyvsp[-6].declspec);
}
    break;

  case 27:
#line 403 "./parser.y"
    {
	yyerror ("Interfaces cannot be named `Object'");
	YYABORT;
}
    break;

  case 28:
#line 407 "./parser.y"
    {
	yyerror ("Interfaces cannot be named `TypeCode'");
	YYABORT;
}
    break;

  case 29:
#line 416 "./parser.y"
    {
	assert (yyvsp[0].tree != NULL);
	assert (IDL_NODE_TYPE (yyvsp[0].tree) == IDLN_IDENT);
	assert (IDL_IDENT_TO_NS (yyvsp[0].tree) != NULL);
	assert (IDL_NODE_TYPE (IDL_IDENT_TO_NS (yyvsp[0].tree)) == IDLN_GENTREE);

	if (IDL_NODE_UP (yyvsp[0].tree) != NULL &&
	    IDL_NODE_TYPE (IDL_NODE_UP (yyvsp[0].tree)) != IDLN_INTERFACE &&
	    IDL_NODE_TYPE (IDL_NODE_UP (yyvsp[0].tree)) != IDLN_FORWARD_DCL) {
		yyerrorl ("Interface definition conflicts",
			  __IDL_prev_token_line - __IDL_cur_token_line);
		do_token_error (IDL_NODE_UP (yyvsp[0].tree), "with", FALSE);
		YYABORT;
	} else if (IDL_NODE_UP (yyvsp[0].tree) != NULL &&
		   IDL_NODE_TYPE (IDL_NODE_UP (yyvsp[0].tree)) != IDLN_FORWARD_DCL) {
		yyerrorv ("Cannot redeclare interface `%s'", IDL_IDENT (yyvsp[0].tree).str);
		IDL_tree_error (yyvsp[0].tree, "Previous declaration of interface `%s'", IDL_IDENT (yyvsp[0].tree).str);
		YYABORT;
	} else if (IDL_NODE_UP (yyvsp[0].tree) != NULL &&
		   IDL_NODE_TYPE (IDL_NODE_UP (yyvsp[0].tree)) == IDLN_FORWARD_DCL)
		__IDL_assign_this_location (yyvsp[0].tree, __IDL_cur_filename, __IDL_cur_line);
}
    break;

  case 30:
#line 439 "./parser.y"
    {
	IDL_GENTREE (IDL_IDENT_TO_NS (yyvsp[-3].tree))._import = yyvsp[0].tree;
	IDL_ns_push_scope (__IDL_root_ns, IDL_IDENT_TO_NS (yyvsp[-3].tree));
	if (IDL_ns_check_for_ambiguous_inheritance (yyvsp[-3].tree, yyvsp[0].tree))
		__IDL_is_okay = FALSE;
}
    break;

  case 31:
#line 446 "./parser.y"
    {
 	yyval.tree = IDL_interface_new (yyvsp[-8].tree, yyvsp[-5].tree, yyvsp[-2].tree);
	assign_declspec (yyval.tree, yyvsp[-11].declspec);
	assign_props (IDL_INTERFACE (yyval.tree).ident, yyvsp[-10].hash_table);
}
    break;

  case 32:
#line 455 "./parser.y"
    {
	if (yyvsp[-3].hash_table) yywarningv (IDL_WARNING1,
			    "Ignoring properties for forward declaration `%s'",
			    IDL_IDENT (yyvsp[-1].tree).str);
	yyval.tree = IDL_forward_dcl_new (yyvsp[-1].tree);
	assign_declspec (yyval.tree, yyvsp[-4].declspec);
}
    break;

  case 33:
#line 464 "./parser.y"
    { yyval.tree = NULL; }
    break;

  case 34:
#line 465 "./parser.y"
    {
	GHashTable *table = g_hash_table_new (g_direct_hash, g_direct_equal);
	gboolean die = FALSE;
	IDL_tree p = yyvsp[0].tree;

	assert (IDL_NODE_TYPE (p) == IDLN_LIST);
	for (; p != NULL && !die; p = IDL_LIST (p).next) {
		assert (IDL_LIST (p).data != NULL);
		assert (IDL_NODE_TYPE (IDL_LIST (p).data) == IDLN_IDENT);

		if (g_hash_table_lookup_extended (table, IDL_LIST (p).data, NULL, NULL)) {
			char *s = IDL_ns_ident_to_qstring (IDL_LIST (p).data, "::", 0);
			yyerrorv ("Cannot inherit from interface `%s' more than once", s);
			g_free (s);
			die = TRUE;
			break;
		} else
			g_hash_table_insert (table, IDL_LIST (p).data, NULL);

		if (IDL_NODE_TYPE (IDL_NODE_UP (IDL_LIST (p).data)) == IDLN_FORWARD_DCL) {
			char *s = IDL_ns_ident_to_qstring (IDL_LIST (p).data, "::", 0);
			yyerrorv ("Incomplete definition of interface `%s'", s);
			IDL_tree_error (IDL_LIST (p).data,
					"Previous forward declaration of `%s'", s);
			g_free (s);
			die = TRUE;
		}
		else if (IDL_NODE_TYPE (IDL_NODE_UP (IDL_LIST (p).data)) != IDLN_INTERFACE) {
			char *s = IDL_ns_ident_to_qstring (IDL_LIST (p).data, "::", 0);
			yyerrorv ("`%s' is not an interface", s);
			IDL_tree_error (IDL_LIST (p).data,
					"Previous declaration of `%s'", s);
			g_free (s);
			die = TRUE;
		}
	}

	g_hash_table_destroy (table);

	if (die)
		YYABORT;

	yyval.tree = yyvsp[0].tree;
}
    break;

  case 35:
#line 511 "./parser.y"
    { yyval.tree = list_start (yyvsp[0].tree, TRUE); }
    break;

  case 36:
#line 513 "./parser.y"
    { yyval.tree = list_chain (yyvsp[-2].tree, yyvsp[0].tree, TRUE); }
    break;

  case 38:
#line 519 "./parser.y"
    { yyval.tree = NULL; }
    break;

  case 39:
#line 520 "./parser.y"
    { yyval.tree = zlist_chain (yyvsp[-1].tree, yyvsp[0].tree, TRUE); }
    break;

  case 47:
#line 532 "./parser.y"
    {
	yyval.tree = yyvsp[0].tree;
	assign_declspec (yyval.tree, yyvsp[-1].declspec);
}
    break;

  case 48:
#line 539 "./parser.y"
    {
	IDL_tree_node node;
	IDL_tree p, dcl;

	yyval.tree = yyvsp[0].tree;
	node.properties = yyvsp[-2].hash_table;
	for (p = IDL_TYPE_DCL (yyvsp[0].tree).dcls; p; p = IDL_LIST (p).next) {
		dcl = IDL_LIST (p).data;
		IDL_tree_properties_copy (&node, dcl);
	}
	__IDL_free_properties (node.properties);
}
    break;

  case 52:
#line 555 "./parser.y"
    {
	yyval.tree = IDL_native_new (yyvsp[0].tree);
	assign_props (IDL_NATIVE (yyval.tree).ident, yyvsp[-2].hash_table);
}
    break;

  case 53:
#line 560 "./parser.y"
    {
	/* Enable native type scanning */
	if (__IDL_pidl > 0)
		__IDL_flagsi |= IDLFP_NATIVE;
	else {
		yyerror ("Native syntax not enabled");
		YYABORT;
	}
}
    break;

  case 54:
#line 568 "./parser.y"
    {
	yyval.tree = IDL_native_new (yyvsp[-3].tree);
	IDL_NATIVE (yyval.tree).user_type = yyvsp[0].str;
	assign_props (IDL_NATIVE (yyval.tree).ident, yyvsp[-5].hash_table);
}
    break;

  case 55:
#line 575 "./parser.y"
    { yyval.tree = IDL_type_dcl_new (yyvsp[-1].tree, yyvsp[0].tree); }
    break;

  case 64:
#line 592 "./parser.y"
    {
	yyerrorv ("Missing identifier in %s definition", yyvsp[0].str);
	YYABORT;
}
    break;

  case 66:
#line 599 "./parser.y"
    {
	yyerrorv ("Missing identifier in %s definition", yyvsp[0].str);
	YYABORT;
}
    break;

  case 68:
#line 607 "./parser.y"
    { yyval.str = "struct"; }
    break;

  case 69:
#line 608 "./parser.y"
    {
	g_hash_table_insert (__IDL_structunion_ht, yyvsp[-1].tree, yyvsp[-1].tree);
	yyval.tree = IDL_type_struct_new (yyvsp[-1].tree, NULL);
}
    break;

  case 70:
#line 612 "./parser.y"
    {
	g_hash_table_remove (__IDL_structunion_ht, yyvsp[-5].tree);
	yyval.tree = yyvsp[-3].tree;
	__IDL_assign_up_node (yyval.tree, yyvsp[-2].tree);
	IDL_TYPE_STRUCT (yyval.tree).member_list = yyvsp[-2].tree;
	assign_props (IDL_TYPE_STRUCT (yyval.tree).ident, yyvsp[-8].hash_table);
}
    break;

  case 71:
#line 622 "./parser.y"
    { yyval.str = "union"; }
    break;

  case 72:
#line 625 "./parser.y"
    {
	g_hash_table_insert (__IDL_structunion_ht, yyvsp[-5].tree, yyvsp[-5].tree);
	yyval.tree = IDL_type_union_new (yyvsp[-5].tree, yyvsp[-2].tree, NULL);
}
    break;

  case 73:
#line 629 "./parser.y"
    {
	g_hash_table_remove (__IDL_structunion_ht, yyvsp[-9].tree);
	yyval.tree = yyvsp[-3].tree;
	__IDL_assign_up_node (yyval.tree, yyvsp[-2].tree);
	IDL_TYPE_UNION (yyval.tree).switch_body = yyvsp[-2].tree;
	assign_props (IDL_TYPE_UNION (yyval.tree).ident, yyvsp[-12].hash_table);
}
    break;

  case 80:
#line 648 "./parser.y"
    { yyval.tree = list_start (yyvsp[0].tree, TRUE); }
    break;

  case 81:
#line 649 "./parser.y"
    { yyval.tree = list_chain (yyvsp[-1].tree, yyvsp[0].tree, TRUE); }
    break;

  case 82:
#line 653 "./parser.y"
    { yyval.tree = IDL_case_stmt_new (yyvsp[-2].tree, yyvsp[-1].tree); }
    break;

  case 83:
#line 656 "./parser.y"
    {
	char *s;

	yyval.tree = IDL_member_new (yyvsp[-1].tree, list_start (yyvsp[0].tree, TRUE));
	if (IDL_NODE_TYPE (yyvsp[-1].tree) == IDLN_IDENT &&
	    g_hash_table_lookup (__IDL_structunion_ht, yyvsp[-1].tree)) {
		s = IDL_ns_ident_to_qstring (yyvsp[0].tree, "::", 0);
		yyerrorv ("Member `%s'", s);
		do_token_error (IDL_NODE_UP (yyvsp[-1].tree), "recurses", TRUE);
		g_free (s);
	}
}
    break;

  case 84:
#line 670 "./parser.y"
    { yyval.tree = list_start (yyvsp[0].tree, FALSE); }
    break;

  case 85:
#line 671 "./parser.y"
    { yyval.tree = list_chain (yyvsp[-1].tree, yyvsp[0].tree, FALSE); }
    break;

  case 86:
#line 674 "./parser.y"
    { yyval.tree = yyvsp[-1].tree; }
    break;

  case 87:
#line 675 "./parser.y"
    { yyval.tree = NULL; }
    break;

  case 88:
#line 678 "./parser.y"
    {
	yyval.tree = yyvsp[0].tree;
	assign_declspec (yyval.tree, yyvsp[-1].declspec);
}
    break;

  case 89:
#line 685 "./parser.y"
    {
	yyval.tree = IDL_const_dcl_new (yyvsp[-3].tree, yyvsp[-2].tree, yyvsp[0].tree);
	/* Should probably do some type checking here... */
}
    break;

  case 90:
#line 691 "./parser.y"
    {
	yyval.tree = yyvsp[0].tree;
	assign_declspec (yyval.tree, yyvsp[-1].declspec);
}
    break;

  case 91:
#line 699 "./parser.y"
    { yyval.tree = IDL_except_dcl_new (yyvsp[-4].tree, yyvsp[-2].tree); }
    break;

  case 92:
#line 702 "./parser.y"
    { yyval.tree = NULL; }
    break;

  case 93:
#line 703 "./parser.y"
    { yyval.tree = zlist_chain (yyvsp[-1].tree, yyvsp[0].tree, TRUE); }
    break;

  case 94:
#line 706 "./parser.y"
    { yyval.boolean = FALSE; }
    break;

  case 95:
#line 707 "./parser.y"
    { yyval.boolean = TRUE; }
    break;

  case 96:
#line 710 "./parser.y"
    {
	yyval.tree = yyvsp[0].tree;
	assign_declspec (yyval.tree, yyvsp[-1].declspec);
}
    break;

  case 97:
#line 719 "./parser.y"
    { yyval.str = "attribute"; }
    break;

  case 98:
#line 721 "./parser.y"
    {
	IDL_tree_node node;
	IDL_tree p, dcl;

	yyval.tree = IDL_attr_dcl_new (yyvsp[-4].boolean, yyvsp[-1].tree, yyvsp[0].tree);
	node.properties = yyvsp[-5].hash_table;
	for (p = yyvsp[0].tree; p; p = IDL_LIST (p).next) {
		dcl = IDL_LIST (p).data;
		IDL_tree_properties_copy (&node, dcl);
	}
	__IDL_free_properties (node.properties);
}
    break;

  case 100:
#line 736 "./parser.y"
    {
	yyerrorv ("Illegal type `void' for %s", yyvsp[-1].str);
	yyval.tree = NULL;
}
    break;

  case 108:
#line 752 "./parser.y"
    {
	illegal_context_type_error (yyvsp[0].tree, yyvsp[-1].str);
	yyval.tree = yyvsp[0].tree;
}
    break;

  case 109:
#line 758 "./parser.y"
    { yyval.boolean = FALSE; }
    break;

  case 110:
#line 759 "./parser.y"
    { yyval.boolean = TRUE; }
    break;

  case 111:
#line 762 "./parser.y"
    {
	yyval.tree = yyvsp[0].tree;
	assign_declspec (yyval.tree, yyvsp[-1].declspec);
}
    break;

  case 112:
#line 773 "./parser.y"
    {
	yyval.tree = IDL_op_dcl_new (yyvsp[-6].boolean, yyvsp[-5].tree, yyvsp[-4].tree, yyvsp[-3].treedata.tree, yyvsp[-1].tree, yyvsp[0].tree);
	IDL_OP_DCL (yyval.tree).f_varargs = GPOINTER_TO_INT (yyvsp[-3].treedata.data);
	assign_props (IDL_OP_DCL (yyval.tree).ident, yyvsp[-7].hash_table);
}
    break;

  case 113:
#line 780 "./parser.y"
    { yyval.str = "operation return value"; }
    break;

  case 114:
#line 781 "./parser.y"
    { yyval.tree = yyvsp[0].tree; }
    break;

  case 115:
#line 782 "./parser.y"
    { yyval.tree = NULL; }
    break;

  case 116:
#line 785 "./parser.y"
    { yyval.boolean = FALSE; }
    break;

  case 117:
#line 786 "./parser.y"
    { yyval.boolean = TRUE; }
    break;

  case 118:
#line 789 "./parser.y"
    { yyval.boolean = FALSE; }
    break;

  case 119:
#line 790 "./parser.y"
    { yyval.boolean = TRUE; }
    break;

  case 120:
#line 796 "./parser.y"
    {
	yyval.treedata.tree = yyvsp[-2].tree;
	yyval.treedata.data = GINT_TO_POINTER (yyvsp[-1].boolean);
}
    break;

  case 121:
#line 800 "./parser.y"
    {
	yyval.treedata.tree = NULL;
	yyval.treedata.data = GINT_TO_POINTER (yyvsp[-1].boolean);
}
    break;

  case 122:
#line 806 "./parser.y"
    { yyval.tree = list_start (yyvsp[0].tree, TRUE); }
    break;

  case 123:
#line 808 "./parser.y"
    { yyval.tree = list_chain (yyvsp[-2].tree, yyvsp[0].tree, TRUE); }
    break;

  case 124:
#line 813 "./parser.y"
    { yyval.str = "parameter"; }
    break;

  case 125:
#line 815 "./parser.y"
    {
	yyval.tree = IDL_param_dcl_new (yyvsp[-3].paramattr, yyvsp[-1].tree, yyvsp[0].tree);
	assign_props (IDL_PARAM_DCL (yyval.tree).simple_declarator, yyvsp[-4].hash_table);
}
    break;

  case 126:
#line 821 "./parser.y"
    { yyval.paramattr = IDL_PARAM_IN; }
    break;

  case 127:
#line 822 "./parser.y"
    { yyval.paramattr = IDL_PARAM_OUT; }
    break;

  case 128:
#line 823 "./parser.y"
    { yyval.paramattr = IDL_PARAM_INOUT; }
    break;

  case 129:
#line 824 "./parser.y"
    {
	yyerrorv ("Missing direction attribute (in, out, inout) before parameter");
	IDL_tree_free (yyvsp[0].tree);
}
    break;

  case 130:
#line 830 "./parser.y"
    { yyval.tree = NULL; }
    break;

  case 132:
#line 834 "./parser.y"
    { yyval.tree = NULL; }
    break;

  case 134:
#line 840 "./parser.y"
    { yyval.tree = yyvsp[-1].tree; }
    break;

  case 135:
#line 845 "./parser.y"
    { yyval.tree = yyvsp[-1].tree; }
    break;

  case 147:
#line 863 "./parser.y"
    { do_binop (yyval.tree, IDL_BINOP_OR, yyvsp[-2].tree, yyvsp[0].tree); }
    break;

  case 149:
#line 867 "./parser.y"
    { do_binop (yyval.tree, IDL_BINOP_XOR, yyvsp[-2].tree, yyvsp[0].tree); }
    break;

  case 151:
#line 871 "./parser.y"
    { do_binop (yyval.tree, IDL_BINOP_AND, yyvsp[-2].tree, yyvsp[0].tree); }
    break;

  case 153:
#line 875 "./parser.y"
    { do_binop (yyval.tree, IDL_BINOP_SHR, yyvsp[-2].tree, yyvsp[0].tree); }
    break;

  case 154:
#line 876 "./parser.y"
    { do_binop (yyval.tree, IDL_BINOP_SHL, yyvsp[-2].tree, yyvsp[0].tree); }
    break;

  case 156:
#line 880 "./parser.y"
    { do_binop (yyval.tree, IDL_BINOP_ADD, yyvsp[-2].tree, yyvsp[0].tree); }
    break;

  case 157:
#line 881 "./parser.y"
    { do_binop (yyval.tree, IDL_BINOP_SUB, yyvsp[-2].tree, yyvsp[0].tree); }
    break;

  case 159:
#line 885 "./parser.y"
    { do_binop (yyval.tree, IDL_BINOP_MULT, yyvsp[-2].tree, yyvsp[0].tree); }
    break;

  case 160:
#line 886 "./parser.y"
    { do_binop (yyval.tree, IDL_BINOP_DIV, yyvsp[-2].tree, yyvsp[0].tree); }
    break;

  case 161:
#line 887 "./parser.y"
    { do_binop (yyval.tree, IDL_BINOP_MOD, yyvsp[-2].tree, yyvsp[0].tree); }
    break;

  case 162:
#line 890 "./parser.y"
    { do_unaryop (yyval.tree, yyvsp[-1].unaryop, yyvsp[0].tree); }
    break;

  case 164:
#line 894 "./parser.y"
    { yyval.unaryop = IDL_UNARYOP_MINUS; }
    break;

  case 165:
#line 895 "./parser.y"
    { yyval.unaryop = IDL_UNARYOP_PLUS; }
    break;

  case 166:
#line 896 "./parser.y"
    { yyval.unaryop = IDL_UNARYOP_COMPLEMENT; }
    break;

  case 167:
#line 899 "./parser.y"
    {
	IDL_tree p, literal;
	
	assert (IDL_NODE_TYPE (yyvsp[0].tree) == IDLN_IDENT);

	p = IDL_NODE_UP (yyvsp[0].tree);
	
	if ((literal = IDL_resolve_const_exp (yyvsp[0].tree, IDLN_ANY))) {
		++IDL_NODE_REFS (literal);
		yyval.tree = literal;
		IDL_tree_free (yyvsp[0].tree);
	} else
		yyval.tree = yyvsp[0].tree;
}
    break;

  case 169:
#line 914 "./parser.y"
    { yyval.tree = yyvsp[-1].tree; }
    break;

  case 176:
#line 926 "./parser.y"
    { yyval.str = "enum"; }
    break;

  case 177:
#line 929 "./parser.y"
    {
	yyval.tree = IDL_type_enum_new (yyvsp[-3].tree, yyvsp[-1].tree);
	assign_props (IDL_TYPE_ENUM (yyval.tree).ident, yyvsp[-6].hash_table);
}
    break;

  case 178:
#line 935 "./parser.y"
    {
	assert (yyvsp[0].tree != NULL);
	assert (IDL_NODE_TYPE (yyvsp[0].tree) == IDLN_GENTREE);
	assert (IDL_NODE_TYPE (IDL_GENTREE (yyvsp[0].tree).data) == IDLN_IDENT);
	yyval.tree = IDL_GENTREE (yyvsp[0].tree).data;
}
    break;

  case 180:
#line 944 "./parser.y"
    { yyval.tree = yyvsp[0].tree; }
    break;

  case 181:
#line 946 "./parser.y"
    {
	IDL_tree p;

	assert (IDL_NODE_TYPE (yyvsp[-2].tree) == IDLN_GENTREE);
	assert (IDL_NODE_TYPE (yyvsp[0].tree) == IDLN_IDENT);

#ifdef YYDEBUG
	if (yydebug)
		fprintf (stderr, "ns: looking in `%s' for `%s'\n", 
		  IDL_IDENT (IDL_GENTREE (yyvsp[-2].tree).data).str, IDL_IDENT(yyvsp[0].tree).str);
#endif

	if ((p = IDL_ns_lookup_this_scope (__IDL_root_ns, yyvsp[-2].tree, yyvsp[0].tree, NULL)) == NULL) {
		yyerrorv ("`%s' undeclared identifier", IDL_IDENT (yyvsp[0].tree).str);
		IDL_tree_free (yyvsp[0].tree);
		YYABORT;
	}
	IDL_tree_free (yyvsp[0].tree);
#ifdef REF_IDENTS
	++IDL_NODE_REFS (IDL_GENTREE (p).data);
#endif
	yyval.tree = p;
}
    break;

  case 182:
#line 971 "./parser.y"
    { yyval.tree = list_start (yyvsp[0].tree, TRUE); }
    break;

  case 183:
#line 973 "./parser.y"
    { yyval.tree = list_chain (yyvsp[-2].tree, yyvsp[0].tree, TRUE); }
    break;

  case 184:
#line 976 "./parser.y"
    { yyval.tree = list_start (yyvsp[0].tree, TRUE); }
    break;

  case 185:
#line 977 "./parser.y"
    { yyval.tree = list_chain (yyvsp[-1].tree, yyvsp[0].tree, TRUE); }
    break;

  case 186:
#line 981 "./parser.y"
    {
	char *s;

	yyval.tree = IDL_member_new (yyvsp[-2].tree, yyvsp[-1].tree);
	if (IDL_NODE_TYPE (yyvsp[-2].tree) == IDLN_IDENT &&
	    g_hash_table_lookup (__IDL_structunion_ht, yyvsp[-2].tree)) {
		s = IDL_ns_ident_to_qstring (IDL_LIST (yyvsp[-1].tree).data, "::", 0);
		yyerrorv ("Member `%s'", s);
		do_token_error (IDL_NODE_UP (yyvsp[-2].tree), "recurses", TRUE);
		g_free (s);
	}
}
    break;

  case 200:
#line 1014 "./parser.y"
    { yyval.tree = IDL_type_sequence_new (yyvsp[-3].tree, yyvsp[-1].tree); }
    break;

  case 201:
#line 1017 "./parser.y"
    { yyval.tree = IDL_type_sequence_new (yyvsp[-1].tree, NULL); }
    break;

  case 202:
#line 1020 "./parser.y"
    { yyval.tree = IDL_type_float_new (IDL_FLOAT_TYPE_FLOAT); }
    break;

  case 203:
#line 1021 "./parser.y"
    { yyval.tree = IDL_type_float_new (IDL_FLOAT_TYPE_DOUBLE); }
    break;

  case 204:
#line 1022 "./parser.y"
    { yyval.tree = IDL_type_float_new (IDL_FLOAT_TYPE_LONGDOUBLE); }
    break;

  case 205:
#line 1027 "./parser.y"
    { yyval.tree = IDL_type_fixed_new (yyvsp[-3].tree, yyvsp[-1].tree); }
    break;

  case 206:
#line 1030 "./parser.y"
    { yyval.tree = IDL_type_fixed_new (NULL, NULL); }
    break;

  case 207:
#line 1033 "./parser.y"
    { yyval.tree = IDL_type_integer_new (TRUE, yyvsp[0].integer); }
    break;

  case 208:
#line 1034 "./parser.y"
    { yyval.tree = IDL_type_integer_new (FALSE, yyvsp[0].integer); }
    break;

  case 209:
#line 1037 "./parser.y"
    { yyval.integer = IDL_INTEGER_TYPE_SHORT; }
    break;

  case 210:
#line 1038 "./parser.y"
    { yyval.integer = IDL_INTEGER_TYPE_LONG; }
    break;

  case 211:
#line 1039 "./parser.y"
    { yyval.integer = IDL_INTEGER_TYPE_LONGLONG; }
    break;

  case 215:
#line 1051 "./parser.y"
    { yyval.integer = IDL_INTEGER_TYPE_SHORT; }
    break;

  case 216:
#line 1052 "./parser.y"
    { yyval.integer = IDL_INTEGER_TYPE_LONG; }
    break;

  case 217:
#line 1053 "./parser.y"
    { yyval.integer = IDL_INTEGER_TYPE_LONGLONG; }
    break;

  case 221:
#line 1065 "./parser.y"
    { yyval.tree = IDL_type_char_new (); }
    break;

  case 222:
#line 1068 "./parser.y"
    { yyval.tree = IDL_type_wide_char_new (); }
    break;

  case 223:
#line 1071 "./parser.y"
    { yyval.tree = IDL_type_boolean_new (); }
    break;

  case 224:
#line 1074 "./parser.y"
    { yyval.tree = IDL_type_octet_new (); }
    break;

  case 225:
#line 1077 "./parser.y"
    { yyval.tree = IDL_type_any_new (); }
    break;

  case 226:
#line 1080 "./parser.y"
    { yyval.tree = IDL_type_object_new (); }
    break;

  case 227:
#line 1083 "./parser.y"
    { yyval.tree = IDL_type_typecode_new (); }
    break;

  case 228:
#line 1088 "./parser.y"
    { yyval.tree = IDL_type_string_new (yyvsp[-1].tree); }
    break;

  case 229:
#line 1089 "./parser.y"
    { yyval.tree = IDL_type_string_new (NULL); }
    break;

  case 230:
#line 1094 "./parser.y"
    { yyval.tree = IDL_type_wide_string_new (yyvsp[-1].tree); }
    break;

  case 231:
#line 1095 "./parser.y"
    { yyval.tree = IDL_type_wide_string_new (NULL); }
    break;

  case 232:
#line 1098 "./parser.y"
    { yyval.tree = list_start (yyvsp[0].tree, TRUE); }
    break;

  case 233:
#line 1100 "./parser.y"
    { yyval.tree = list_chain (yyvsp[-2].tree, yyvsp[0].tree, TRUE); }
    break;

  case 238:
#line 1113 "./parser.y"
    { yyval.tree = list_start (yyvsp[0].tree, TRUE); }
    break;

  case 239:
#line 1115 "./parser.y"
    { yyval.tree = list_chain (yyvsp[-2].tree, yyvsp[0].tree, TRUE); }
    break;

  case 240:
#line 1119 "./parser.y"
    {
	IDL_tree p;
	int i;

	yyval.tree = IDL_type_array_new (yyvsp[-1].tree, yyvsp[0].tree);
	for (i = 1, p = yyvsp[0].tree; p; ++i, p = IDL_LIST (p).next)
		if (!IDL_LIST (p).data) {
			char *s = IDL_ns_ident_to_qstring (yyvsp[-1].tree, "::", 0);
			yyerrorv ("Missing value in dimension %d of array `%s'", i, s);
			g_free (s);
		}
}
    break;

  case 241:
#line 1133 "./parser.y"
    { yyval.tree = list_start (yyvsp[0].tree, FALSE); }
    break;

  case 242:
#line 1135 "./parser.y"
    { yyval.tree = list_chain (yyvsp[-1].tree, yyvsp[0].tree, FALSE); }
    break;

  case 243:
#line 1138 "./parser.y"
    { yyval.tree = yyvsp[-1].tree; }
    break;

  case 244:
#line 1139 "./parser.y"
    { yyval.tree = NULL; }
    break;

  case 245:
#line 1143 "./parser.y"
    {
	yyval.hash_table = g_hash_table_new (IDL_strcase_hash, IDL_strcase_equal);
	g_hash_table_insert (yyval.hash_table, yyvsp[-1].str, yyvsp[0].str);
}
    break;

  case 246:
#line 1149 "./parser.y"
    {
	yyval.hash_table = yyvsp[-3].hash_table;
	g_hash_table_insert (yyval.hash_table, yyvsp[-1].str, yyvsp[0].str);
}
    break;

  case 247:
#line 1153 "./parser.y"
    {
	yyval.hash_table = g_hash_table_new (IDL_strcase_hash, IDL_strcase_equal);
	g_hash_table_insert (yyval.hash_table, yyvsp[0].str, g_strdup (""));
}
    break;

  case 248:
#line 1158 "./parser.y"
    {
	yyval.hash_table = yyvsp[-2].hash_table;
	g_hash_table_insert (yyval.hash_table, yyvsp[0].str, g_strdup (""));
}
    break;

  case 249:
#line 1164 "./parser.y"
    { yyval.tree = IDL_ident_new (yyvsp[0].str); }
    break;

  case 250:
#line 1167 "./parser.y"
    {
	assert (yyvsp[0].tree != NULL);
	assert (IDL_NODE_TYPE (yyvsp[0].tree) == IDLN_GENTREE);
	assert (IDL_NODE_TYPE (IDL_GENTREE (yyvsp[0].tree).data) == IDLN_IDENT);
	yyval.tree = IDL_GENTREE (yyvsp[0].tree).data;
}
    break;

  case 251:
#line 1175 "./parser.y"
    {
	IDL_tree	old_top = IDL_GENTREE (IDL_NS (__IDL_root_ns).current).data;
	IDL_ns_push_scope (__IDL_root_ns, yyvsp[0].tree);
#ifdef YYDEBUG
	if (yydebug)
		fprintf (stderr, "ns: entering new scope `%s' of `%s'\n", 
		       IDL_IDENT (IDL_GENTREE (IDL_NS (__IDL_root_ns).current).data).str, IDL_IDENT(old_top).str);
#endif
	assert (IDL_NODE_TYPE (IDL_GENTREE (yyvsp[0].tree).data) == IDLN_IDENT);
	yyval.tree = IDL_GENTREE (yyvsp[0].tree).data;
}
    break;

  case 252:
#line 1188 "./parser.y"
    {
	IDL_tree	old_top = IDL_GENTREE (IDL_NS (__IDL_root_ns).current).data;
	IDL_ns_push_scope (__IDL_root_ns, yyvsp[0].tree);
	assert (IDL_NS (__IDL_root_ns).current != NULL);
	assert (IDL_NODE_TYPE (IDL_NS (__IDL_root_ns).current) == IDLN_GENTREE);
	assert (IDL_GENTREE (IDL_NS (__IDL_root_ns).current).data != NULL);
	assert (IDL_NODE_TYPE (IDL_GENTREE (IDL_NS (__IDL_root_ns).current).data) == IDLN_IDENT);
#ifdef YYDEBUG
	if (yydebug)
		fprintf (stderr,"ns: entering new/prev scope `%s' of `%s'\n",
		       IDL_IDENT (IDL_GENTREE (IDL_NS (__IDL_root_ns).current).data).str, IDL_IDENT(old_top).str);
#endif
	assert (IDL_NODE_TYPE (IDL_GENTREE (yyvsp[0].tree).data) == IDLN_IDENT);
	yyval.tree = IDL_GENTREE (yyvsp[0].tree).data;
}
    break;

  case 253:
#line 1205 "./parser.y"
    {
	IDL_tree cur_top = IDL_GENTREE (IDL_NS (__IDL_root_ns).current).data;
	IDL_ns_pop_scope (__IDL_root_ns);
#ifdef YYDEBUG
	if (yydebug)
		fprintf (stderr, "ns: pop scope from `%s' to `%s'\n", 
		       IDL_IDENT(cur_top).str,
		       IDL_IDENT (IDL_GENTREE (IDL_NS (__IDL_root_ns).current).data).str);
#endif
}
    break;

  case 254:
#line 1217 "./parser.y"
    {
	IDL_tree p;

	if ((p = IDL_ns_place_new (__IDL_root_ns, yyvsp[0].tree)) == NULL) {
		IDL_tree q;
		int i;

		p = IDL_ns_lookup_cur_scope (__IDL_root_ns, yyvsp[0].tree, NULL);

		for (i = 0, q = IDL_GENTREE (p).data;
		     q && (IDL_NODE_TYPE (q) == IDLN_IDENT ||
			   IDL_NODE_TYPE (q) == IDLN_LIST) && i < 4;
		     ++i)
			if (IDL_NODE_UP (q))
				q = IDL_NODE_UP (q);

		if (q) {
			IDL_tree_error (yyvsp[0].tree, "`%s' conflicts", IDL_IDENT (yyvsp[0].tree).str);
			do_token_error (q, "with", FALSE);
		} else
			yyerrorv ("`%s' duplicate identifier", IDL_IDENT (yyvsp[0].tree).str);

		IDL_tree_free (yyvsp[0].tree);
		YYABORT;
	}
	assert (IDL_IDENT (yyvsp[0].tree)._ns_ref == p);
#ifdef REF_IDENTS
	++IDL_NODE_REFS (IDL_GENTREE (p).data);
#endif
	if (__IDL_new_ident_comments != NULL) {
		assert (IDL_IDENT (yyvsp[0].tree).comments == NULL);
		IDL_IDENT (yyvsp[0].tree).comments = __IDL_new_ident_comments;
		__IDL_new_ident_comments = NULL;
	}
	yyval.tree = p;
}
    break;

  case 255:
#line 1255 "./parser.y"
    {
	IDL_tree p;

	if ((p = IDL_ns_resolve_ident (__IDL_root_ns, yyvsp[0].tree)) == NULL) {
		yyerrorv ("`%s' undeclared identifier", IDL_IDENT (yyvsp[0].tree).str);
		IDL_tree_free (yyvsp[0].tree);
		YYABORT;
	}
	IDL_tree_free (yyvsp[0].tree);
	assert (IDL_GENTREE (p).data != NULL);
	assert (IDL_IDENT (IDL_GENTREE (p).data)._ns_ref == p);
#ifdef REF_IDENTS
	++IDL_NODE_REFS (IDL_GENTREE (p).data);
#endif
	yyval.tree = p;
}
    break;

  case 256:
#line 1274 "./parser.y"
    {
	IDL_tree p;

	if ((p = IDL_ns_lookup_cur_scope (__IDL_root_ns, yyvsp[0].tree, NULL)) == NULL) {
#ifdef YYDEBUG
		if (yydebug)
			fprintf (stderr, "ns: place_new `%s' in `%s'\n", 
		  	  IDL_IDENT(yyvsp[0].tree).str,
			  IDL_IDENT(IDL_GENTREE (IDL_NS (__IDL_root_ns).current).data).str );
#endif
		p = IDL_ns_place_new (__IDL_root_ns, yyvsp[0].tree);
		assert (p != NULL);
		assert (IDL_IDENT (yyvsp[0].tree)._ns_ref == p);
		if (__IDL_new_ident_comments != NULL) {
			assert (IDL_IDENT (yyvsp[0].tree).comments == NULL);
			IDL_IDENT (yyvsp[0].tree).comments = __IDL_new_ident_comments;
			__IDL_new_ident_comments = NULL;
		}
	} else {
		IDL_tree_free (yyvsp[0].tree);
		assert (IDL_GENTREE (p).data != NULL);
		assert (IDL_IDENT (IDL_GENTREE (p).data)._ns_ref == p);
	}
#ifdef REF_IDENTS
	++IDL_NODE_REFS (IDL_GENTREE (p).data);
#endif
	yyval.tree = p;
}
    break;

  case 257:
#line 1304 "./parser.y"
    {
	IDL_tree p;

	if ((p = IDL_ns_lookup_this_scope (
		__IDL_root_ns,IDL_NS (__IDL_root_ns).file, yyvsp[0].tree, NULL)) == NULL) {
		yyerrorv ("`%s' undeclared identifier", IDL_IDENT (yyvsp[0].tree).str);
		IDL_tree_free (yyvsp[0].tree);
		YYABORT;
	}
	IDL_tree_free (yyvsp[0].tree);
	assert (IDL_GENTREE (p).data != NULL);
	assert (IDL_IDENT (IDL_GENTREE (p).data)._ns_ref == p);
#ifdef REF_IDENTS
	++IDL_NODE_REFS (IDL_GENTREE (p).data);
#endif
	yyval.tree = p;
}
    break;

  case 258:
#line 1323 "./parser.y"
    { yyval.tree = list_start (yyvsp[0].tree, TRUE); }
    break;

  case 259:
#line 1325 "./parser.y"
    { yyval.tree = list_chain (yyvsp[-2].tree, yyvsp[0].tree, TRUE); }
    break;

  case 260:
#line 1328 "./parser.y"
    {
	IDL_tree literal, ident = NULL;
	IDL_longlong_t value = 0;

	if ((literal = IDL_resolve_const_exp (yyvsp[0].tree, IDLN_INTEGER))) {
		assert (IDL_NODE_TYPE (literal) == IDLN_INTEGER);
		++IDL_NODE_REFS (literal);
		value = IDL_INTEGER (literal).value;
		if ( literal != yyvsp[0].tree )
			IDL_tree_free (yyvsp[0].tree);
	}

	if (literal && IDL_NODE_UP (literal) &&
	    IDL_NODE_TYPE (IDL_NODE_UP (literal)) == IDLN_CONST_DCL)
		ident = IDL_CONST_DCL (IDL_NODE_UP (literal)).ident;
	
	if (literal == NULL) {
		if (!(__IDL_flags & IDLF_NO_EVAL_CONST))
			yyerror ("Could not resolve constant expression");
		yyval.tree = yyvsp[0].tree;
	} else if (value == 0) {
		yyerror ("Zero array size is illegal");
		if (ident)
			IDL_tree_error (ident, "From constant declared here");
		yyval.tree = NULL;
	} else if (value < 0) {
		yywarningv (IDL_WARNING1, "Cannot use negative value %"
			    IDL_LL "d, using %" IDL_LL "d",
			   value, -value);
		if (ident)
			IDL_tree_warning (ident,
					  IDL_WARNING1, "From constant declared here");
		yyval.tree = IDL_integer_new (-value);
	}
	else
		yyval.tree = IDL_integer_new (value);
}
    break;

  case 261:
#line 1367 "./parser.y"
    { yyval.declspec = 0; }
    break;

  case 262:
#line 1368 "./parser.y"
    {
	yyval.declspec = IDL_parse_declspec (yyvsp[0].str);
	g_free (yyvsp[0].str);
}
    break;

  case 263:
#line 1374 "./parser.y"
    { yyval.hash_table = NULL; }
    break;

  case 264:
#line 1375 "./parser.y"
    {
	/* Enable property scanning */
	if (__IDL_flags & IDLF_PROPERTIES)
		__IDL_flagsi |= IDLFP_PROPERTIES;
	else {
		yyerror ("Property syntax not enabled");
		YYABORT;
	}
}
    break;

  case 265:
#line 1384 "./parser.y"
    { yyval.hash_table = yyvsp[-1].hash_table; }
    break;

  case 266:
#line 1387 "./parser.y"
    { yyval.tree = IDL_integer_new (yyvsp[0].integer); }
    break;

  case 267:
#line 1390 "./parser.y"
    { yyval.tree = IDL_string_new (yyvsp[0].str); }
    break;

  case 268:
#line 1393 "./parser.y"
    { yyval.tree = IDL_char_new (yyvsp[0].str); }
    break;

  case 269:
#line 1396 "./parser.y"
    { yyval.tree = IDL_fixed_new (yyvsp[0].str); }
    break;

  case 270:
#line 1399 "./parser.y"
    { yyval.tree = IDL_float_new (yyvsp[0].floatp); }
    break;

  case 271:
#line 1402 "./parser.y"
    { yyval.tree = IDL_boolean_new (TRUE); }
    break;

  case 272:
#line 1403 "./parser.y"
    { yyval.tree = IDL_boolean_new (FALSE); }
    break;

  case 273:
#line 1406 "./parser.y"
    {
	yyval.tree = yyvsp[0].tree;
	assign_declspec (yyval.tree, yyvsp[-1].declspec);
}
    break;

  case 274:
#line 1412 "./parser.y"
    {
	yyval.tree = yyvsp[0].tree;
}
    break;

  case 276:
#line 1418 "./parser.y"
    {
	char *catstr = g_malloc (strlen (yyvsp[-1].str) + strlen (yyvsp[0].str) + 1);
	strcpy (catstr, yyvsp[-1].str); g_free (yyvsp[-1].str);
	strcat (catstr, yyvsp[0].str); g_free (yyvsp[0].str);
	yyval.str = catstr;
}
    break;

  case 277:
#line 1426 "./parser.y"
    {
	char *s = IDL_do_escapes (yyvsp[0].str);
	g_free (yyvsp[0].str);
	yyval.str = s;
}
    break;

  case 278:
#line 1433 "./parser.y"
    {
	char *s = IDL_do_escapes (yyvsp[0].str);
	g_free (yyvsp[0].str);
	yyval.str = s;
}
    break;


    }

/* Line 991 of yacc.c.  */
#line 3105 "y.tab.c"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = yyn < 0 ? -yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("syntax error, unexpected ") + 1;
	  yysize += yystrlen (yytname[yytype]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "syntax error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = yyn < 0 ? -yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("syntax error");
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* Return failure if at end of input.  */
      if (yychar == YYEOF)
        {
	  /* Pop the error token.  */
          YYPOPSTACK;
	  /* Pop the rest of the stack.  */
	  while (yyss < yyssp)
	    {
	      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
	      yydestruct (yystos[*yyssp], yyvsp);
	      YYPOPSTACK;
	    }
	  YYABORT;
        }

      YYDSYMPRINTF ("Error: discarding", yytoken, &yylval, &yylloc);
      yydestruct (yytoken, &yylval);
      yychar = YYEMPTY;

    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab2;


/*----------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action.  |
`----------------------------------------------------*/
yyerrlab1:

  /* Suppress GCC warning that yyerrlab1 is unused when no action
     invokes YYERROR.  */
#if defined (__GNUC_MINOR__) && 2093 <= (__GNUC__ * 1000 + __GNUC_MINOR__)
  __attribute__ ((__unused__))
#endif


  goto yyerrlab2;


/*---------------------------------------------------------------.
| yyerrlab2 -- pop states until the error token can be shifted.  |
`---------------------------------------------------------------*/
yyerrlab2:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
      yydestruct (yystos[yystate], yyvsp);
      yyvsp--;
      yystate = *--yyssp;

      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;


  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 1440 "./parser.y"


void __IDL_parser_reset (void)
{
	yyclearin;
}

static const char *IDL_ns_get_cur_prefix (IDL_ns ns)
{
	IDL_tree p;

	p = IDL_NS (ns).current;

	assert (p != NULL);

	while (p && !IDL_GENTREE (p)._cur_prefix)
		p = IDL_NODE_UP (p);

	return p ? IDL_GENTREE (p)._cur_prefix : NULL;
}

gchar *IDL_ns_ident_make_repo_id (IDL_ns ns, IDL_tree p,
				  const char *p_prefix, int *major, int *minor)
{
	GString *s = g_string_new (NULL);
	const char *prefix;
	char *q;

	assert (p != NULL);
	
	if (IDL_NODE_TYPE (p) == IDLN_IDENT)
		p = IDL_IDENT_TO_NS (p);

	assert (p != NULL);

	prefix = p_prefix ? p_prefix : IDL_ns_get_cur_prefix (ns);

	q = IDL_ns_ident_to_qstring (p, "/", 0);
	g_string_printf (s, "IDL:%s%s%s:%d.%d",
			  prefix ? prefix : "",
			  prefix && *prefix ? "/" : "",
			  q,
			  major ? *major : 1,
			  minor ? *minor : 0);
	g_free (q);

	q = s->str;
	g_string_free (s, FALSE);

	return q;
}

static const char *get_name_token (const char *s, char **tok)
{
	const char *begin = s;
	int state = 0;

	if (!s)
		return NULL;

	while (g_ascii_isspace (*s)) ++s;
	
	while (1) switch (state) {
	case 0:		/* Unknown */
		if (*s == ':')
			state = 1;
		else if (isalnum ((int)*s) || *s == '_') {
			begin = s;
			state = 2;
		} else
			return NULL;
		break;
	case 1:		/* Scope */
		if (strncmp (s, "::", 2) == 0) {
			char *r = g_malloc (3);
			strcpy (r, "::");
			*tok = r;
			return s + 2;
		} else	/* Invalid */
			return NULL;
		break;
	case 2:
		if (isalnum ((int)*s) || *s == '_')
			++s;
		else {
			char *r = g_malloc (s - begin + 1);
			strncpy (r, begin, s - begin + 1);
			r[s - begin] = 0;
			*tok = r;
			return s;
		}
		break;
	}
}

static IDL_tree IDL_ns_pragma_parse_name (IDL_ns ns, const char *s)
{
	IDL_tree p = IDL_NS (ns).current, q;
	int start = 1;
	char *tok;

	/* This is a hack to allow directives for an ident (such
	 * as and interface) to be located within the scope of
	 * that identifier. */
	if ( p && (q=IDL_GENTREE(p).data)!=0
	  && IDL_NODE_TYPE(q)==IDLN_IDENT
	  && strcmp(s,IDL_IDENT(q).str)==0 ) {
		return p;
	}

	while (p && *s && (s = get_name_token (s, &tok))) {
		if (tok == NULL)
			return NULL;
		if (strcmp (tok, "::") == 0) {
			if (start) {
				/* Globally scoped */
				p = IDL_NS (ns).file;
			}
			g_free (tok);
		} else {
			IDL_tree ident = IDL_ident_new (tok);
			p = IDL_ns_lookup_this_scope (__IDL_root_ns, p, ident, NULL);
			IDL_tree_free (ident);
		}
		start = 0;
	}
	
	return p;
}

void IDL_ns_ID (IDL_ns ns, const char *s)
{
	char name[1024], id[1024];
	IDL_tree p, ident;
	int n;

	n = sscanf (s, "%1023s \"%1023s\"", name, id);
	if (n < 2 && __IDL_is_parsing) {
		yywarning (IDL_WARNING1, "Malformed pragma ID");
		return;
	}
	if (id[strlen (id) - 1] == '"')
		id[strlen (id) - 1] = 0;

	p = IDL_ns_pragma_parse_name (__IDL_root_ns, name);
	if (!p && __IDL_is_parsing) {
		yywarningv (IDL_WARNING1, "Unknown identifier `%s' in pragma ID", name);
		return;
	}

	/* We have resolved the identifier, so assign the repo id */
	assert (IDL_NODE_TYPE (p) == IDLN_GENTREE);
	assert (IDL_GENTREE (p).data != NULL);
	assert (IDL_NODE_TYPE (IDL_GENTREE (p).data) == IDLN_IDENT);
	ident = IDL_GENTREE (p).data;

	if (IDL_IDENT_REPO_ID (ident) != NULL)
		g_free (IDL_IDENT_REPO_ID (ident));

	IDL_IDENT_REPO_ID (ident) = g_strdup (id);
}

void IDL_ns_version (IDL_ns ns, const char *s)
{
	char name[1024];
	int n, major, minor;
	IDL_tree p, ident;

	n = sscanf (s, "%1023s %u.%u", name, &major, &minor);
	if (n < 3 && __IDL_is_parsing) {
		yywarning (IDL_WARNING1, "Malformed pragma version");
		return;
	}

	p = IDL_ns_pragma_parse_name (__IDL_root_ns, name);
	if (!p && __IDL_is_parsing) {
		yywarningv (IDL_WARNING1, "Unknown identifier `%s' in pragma version", name);
		return;
	}

	/* We have resolved the identifier, so assign the repo id */
	assert (IDL_NODE_TYPE (p) == IDLN_GENTREE);
	assert (IDL_GENTREE (p).data != NULL);
	assert (IDL_NODE_TYPE (IDL_GENTREE (p).data) == IDLN_IDENT);
	ident = IDL_GENTREE (p).data;

	if (IDL_IDENT_REPO_ID (ident) != NULL) {
		char *v = strrchr (IDL_IDENT_REPO_ID (ident), ':');
		if (v) {
			GString *s;

			*v = 0;
			s = g_string_new (NULL);
			g_string_printf (s, "%s:%d.%d",
					  IDL_IDENT_REPO_ID (ident), major, minor);
			g_free (IDL_IDENT_REPO_ID (ident));
			IDL_IDENT_REPO_ID (ident) = s->str;
			g_string_free (s, FALSE);
		} else if (__IDL_is_parsing)
			yywarningv (IDL_WARNING1, "Cannot find RepositoryID OMG IDL version in ID `%s'",
				    IDL_IDENT_REPO_ID (ident));
	} else
		IDL_IDENT_REPO_ID (ident) =
			IDL_ns_ident_make_repo_id (
				__IDL_root_ns, p, NULL, &major, &minor);
}

int IDL_inhibit_get (void)
{
	g_return_val_if_fail (__IDL_is_parsing, -1);

	return __IDL_inhibits;
}

void IDL_inhibit_push (void)
{
	g_return_if_fail (__IDL_is_parsing);

	++__IDL_inhibits;
}

void IDL_inhibit_pop (void)
{
	g_return_if_fail (__IDL_is_parsing);

	if (--__IDL_inhibits < 0)
		__IDL_inhibits = 0;
}

static void IDL_inhibit (IDL_ns ns, const char *s)
{
	if (g_ascii_strcasecmp ("push", s) == 0)
		IDL_inhibit_push ();
	else if (g_ascii_strcasecmp ("pop", s) == 0)
		IDL_inhibit_pop ();
}

static void IDL_typecodes_as_tok (IDL_ns ns, const char *s)
{
	if (g_ascii_strcasecmp ("push", s) == 0)
		++(__IDL_typecodes_as_tok);
	else if (g_ascii_strcasecmp ("pop", s) == 0)
		--(__IDL_typecodes_as_tok);
}

static void IDL_pidl (IDL_ns ns, const char *s)
{
	if (g_ascii_strcasecmp ("push", s) == 0)
		++(__IDL_pidl);
	else if (g_ascii_strcasecmp ("pop", s) == 0)
		--(__IDL_pidl);
}

void __IDL_do_pragma (const char *s)
{
	int n;
	char directive[256];

	g_return_if_fail (__IDL_is_parsing);
	g_return_if_fail (s != NULL);

	if (sscanf (s, "%255s%n", directive, &n) < 1)
		return;
	s += n;
	while (g_ascii_isspace (*s)) ++s;

	if (strcmp (directive, "prefix") == 0)
		IDL_ns_prefix (__IDL_root_ns, s);
	else if (strcmp (directive, "ID") == 0)
		IDL_ns_ID (__IDL_root_ns, s);
	else if (strcmp (directive, "version") == 0)
		IDL_ns_version (__IDL_root_ns, s);
	else if (strcmp (directive, "inhibit") == 0)
		IDL_inhibit (__IDL_root_ns, s);
	else if (strcmp (directive, "typecodes_as_tok") == 0)
		IDL_typecodes_as_tok (__IDL_root_ns, s);
	else if (strcmp (directive, "pidl") == 0)
		IDL_pidl (__IDL_root_ns, s);
}

static IDL_declspec_t IDL_parse_declspec (const char *strspec)
{
	IDL_declspec_t flags = IDLF_DECLSPEC_EXIST;

	if (strspec == NULL)
		return flags;

	if (strcmp (strspec, "inhibit") == 0)
		flags |= IDLF_DECLSPEC_INHIBIT;
	if (strcmp (strspec, "pidl") == 0)
		flags |= IDLF_DECLSPEC_PIDL;
	else if (__IDL_is_parsing)
		yywarningv (IDL_WARNING1, "Ignoring unknown declspec `%s'", strspec);

	return flags;
}

IDL_tree IDL_file_set (const char *filename, int line)
{
	IDL_fileinfo *fi;
	IDL_tree tree = NULL;

	g_return_val_if_fail (__IDL_is_parsing, 0);

	if (filename) {
		const char *oldfilename = __IDL_cur_filename;
		gboolean wasInhibit = IS_INHIBIT_STATE();
		gboolean isTop = 
#ifdef HAVE_CPP_PIPE_STDIN
			strlen (filename)==0;
#else
			__IDL_tmp_filename &&
			strcmp (filename, __IDL_tmp_filename)==0;
#endif
		if ( isTop ) {
			filename = __IDL_real_filename;
			__IDL_flagsi &= ~IDLFP_IN_INCLUDES;
		} else {
			__IDL_flagsi |= IDLFP_IN_INCLUDES;
		}

		if ((fi=g_hash_table_lookup(__IDL_filename_hash, filename)) ) {
			__IDL_cur_fileinfo = fi;
			++(fi->seenCnt);
		} else {
			fi = g_new0 (IDL_fileinfo, 1);
			fi->name = g_strdup(filename);
			g_hash_table_insert (__IDL_filename_hash, fi->name, fi);
		}
		__IDL_cur_fileinfo = fi;
		__IDL_cur_filename = fi->name;
		if ( (__IDL_flags & IDLF_SRCFILES)!=0
		  && (oldfilename==0 
		  	    || strcmp(oldfilename,fi->name)!=0) ) {
			tree = IDL_srcfile_new(fi->name, fi->seenCnt, isTop, wasInhibit);
		}
	}

	if (__IDL_cur_line > 0)
		__IDL_cur_line = line;
	return tree;
}

void IDL_file_get (const char **filename, int *line)
{
	g_return_if_fail (__IDL_is_parsing);

	if (filename)
		*filename = __IDL_cur_filename;

	if (line)
		*line = __IDL_cur_line;
}

static int do_token_error (IDL_tree p, const char *message, gboolean prev)
{
	int dienow;
	char *what = NULL, *who = NULL;

	assert (p != NULL);

	dienow = IDL_tree_get_node_info (p, &what, &who);

	assert (what != NULL);
	
	if (who && *who)
		IDL_tree_error (p, "%s %s `%s'", message, what, who);
	else
		IDL_tree_error (p, "%s %s", message, what);
	
	return dienow;
}

static void illegal_context_type_error (IDL_tree p, const char *what)
{
	GString *s = g_string_new (NULL);

	g_string_printf (s, "Illegal type `%%s' for %s", what);
	illegal_type_error (p, s->str);
	g_string_free (s, TRUE);
}

static void illegal_type_error (IDL_tree p, const char *message)
{
	GString *s;

	s = IDL_tree_to_IDL_string (p, NULL, IDLF_OUTPUT_NO_NEWLINES);
	yyerrorv (message, s->str);
	g_string_free (s, TRUE);
}

static IDL_tree list_start (IDL_tree a, gboolean filter_null)
{
	IDL_tree p;

	if (!a && filter_null)
		return NULL;

	p = IDL_list_new (a);

	return p;
}

static IDL_tree list_chain (IDL_tree a, IDL_tree b, gboolean filter_null)
{
	IDL_tree p;

	if (filter_null) {
		if (!b)
			return a;
		if (!a)
			return list_start (b, filter_null);
	}

	p = IDL_list_new (b);
	a = IDL_list_concat (a, p);

	return a;
}

static IDL_tree zlist_chain (IDL_tree a, IDL_tree b, gboolean filter_null)
{
	if (a == NULL)
		return list_start (b, filter_null);
	else
		return list_chain (a, b, filter_null);
}

static int IDL_binop_chktypes (enum IDL_binop op, IDL_tree a, IDL_tree b)
{
	if (IDL_NODE_TYPE (a) != IDLN_BINOP &&
	    IDL_NODE_TYPE (b) != IDLN_BINOP &&
	    IDL_NODE_TYPE (a) != IDLN_UNARYOP &&
	    IDL_NODE_TYPE (b) != IDLN_UNARYOP &&
	    IDL_NODE_TYPE (a) != IDL_NODE_TYPE (b)) {
		yyerror ("Invalid mix of types in constant expression");
		return -1;
	}

	switch (op) {
	case IDL_BINOP_MULT:
	case IDL_BINOP_DIV:
	case IDL_BINOP_ADD:
	case IDL_BINOP_SUB:
		break;

	case IDL_BINOP_MOD:
	case IDL_BINOP_SHR:
	case IDL_BINOP_SHL:
	case IDL_BINOP_AND:
	case IDL_BINOP_OR:
	case IDL_BINOP_XOR:
		if ((IDL_NODE_TYPE (a) != IDLN_INTEGER ||
		     IDL_NODE_TYPE (b) != IDLN_INTEGER) &&
		    !(IDL_NODE_TYPE (a) == IDLN_BINOP ||
		      IDL_NODE_TYPE (b) == IDLN_BINOP ||
		      IDL_NODE_TYPE (a) == IDLN_UNARYOP ||
		      IDL_NODE_TYPE (b) == IDLN_UNARYOP)) {
			yyerror ("Invalid operation on non-integer value");
			return -1;
		}
		break;
	}

	return 0;
}

static int IDL_unaryop_chktypes (enum IDL_unaryop op, IDL_tree a)
{
	switch (op) {
	case IDL_UNARYOP_PLUS:
	case IDL_UNARYOP_MINUS:
		break;

	case IDL_UNARYOP_COMPLEMENT:
		if (IDL_NODE_TYPE (a) != IDLN_INTEGER &&
		    !(IDL_NODE_TYPE (a) == IDLN_BINOP ||
		      IDL_NODE_TYPE (a) == IDLN_UNARYOP)) {
			yyerror ("Operand to complement must be integer");
			return -1;
		}
		break;
	}

	return 0;
}

static IDL_tree IDL_binop_eval_integer (enum IDL_binop op, IDL_tree a, IDL_tree b)
{
	IDL_tree p = NULL;

	assert (IDL_NODE_TYPE (a) == IDLN_INTEGER);

	switch (op) {
	case IDL_BINOP_MULT:
		p = IDL_integer_new (IDL_INTEGER (a).value * IDL_INTEGER (b).value);
		break;

	case IDL_BINOP_DIV:
		if (IDL_INTEGER (b).value == 0) {
			yyerror ("Divide by zero in constant expression");
			return NULL;
		}
		p = IDL_integer_new (IDL_INTEGER (a).value / IDL_INTEGER (b).value);
		break;

	case IDL_BINOP_ADD:
		p = IDL_integer_new (IDL_INTEGER (a).value + IDL_INTEGER (b).value);
		break;

	case IDL_BINOP_SUB:
		p = IDL_integer_new (IDL_INTEGER (a).value - IDL_INTEGER (b).value);
		break;

	case IDL_BINOP_MOD:
		if (IDL_INTEGER (b).value == 0) {
			yyerror ("Modulo by zero in constant expression");
			return NULL;
		}
		p = IDL_integer_new (IDL_INTEGER (a).value % IDL_INTEGER (b).value);
		break;

	case IDL_BINOP_SHR:
		p = IDL_integer_new (IDL_INTEGER (a).value >> IDL_INTEGER (b).value);
		break;

	case IDL_BINOP_SHL:
		p = IDL_integer_new (IDL_INTEGER (a).value << IDL_INTEGER (b).value);
		break;

	case IDL_BINOP_AND:
		p = IDL_integer_new (IDL_INTEGER (a).value & IDL_INTEGER (b).value);
		break;

	case IDL_BINOP_OR:
		p = IDL_integer_new (IDL_INTEGER (a).value | IDL_INTEGER (b).value);
		break;

	case IDL_BINOP_XOR:
		p = IDL_integer_new (IDL_INTEGER (a).value ^ IDL_INTEGER (b).value);
		break;
	}

	return p;
}

static IDL_tree IDL_binop_eval_float (enum IDL_binop op, IDL_tree a, IDL_tree b)
{
	IDL_tree p = NULL;

	assert (IDL_NODE_TYPE (a) == IDLN_FLOAT);

	switch (op) {
	case IDL_BINOP_MULT:
		p = IDL_float_new (IDL_FLOAT (a).value * IDL_FLOAT (b).value);
		break;

	case IDL_BINOP_DIV:
		if (IDL_FLOAT (b).value == 0.0) {
			yyerror ("Divide by zero in constant expression");
			return NULL;
		}
		p = IDL_float_new (IDL_FLOAT (a).value / IDL_FLOAT (b).value);
		break;

	case IDL_BINOP_ADD:
		p = IDL_float_new (IDL_FLOAT (a).value + IDL_FLOAT (b).value);
		break;

	case IDL_BINOP_SUB:
		p = IDL_float_new (IDL_FLOAT (a).value - IDL_FLOAT (b).value);
		break;

	default:
		break;
	}

	return p;
}

static IDL_tree IDL_binop_eval (enum IDL_binop op, IDL_tree a, IDL_tree b)
{
	assert (IDL_NODE_TYPE (a) == IDL_NODE_TYPE (b));

	switch (IDL_NODE_TYPE (a)) {
	case IDLN_INTEGER: return IDL_binop_eval_integer (op, a, b);
	case IDLN_FLOAT: return IDL_binop_eval_float (op, a, b);
	default: return NULL;
	}
}

static IDL_tree IDL_unaryop_eval_integer (enum IDL_unaryop op, IDL_tree a)
{
	IDL_tree p = NULL;

	assert (IDL_NODE_TYPE (a) == IDLN_INTEGER);

	switch (op) {
	case IDL_UNARYOP_PLUS:
		p = IDL_integer_new (IDL_INTEGER (a).value);
		break;

	case IDL_UNARYOP_MINUS:
		p = IDL_integer_new (-IDL_INTEGER (a).value);
		break;

	case IDL_UNARYOP_COMPLEMENT:
		p = IDL_integer_new (~IDL_INTEGER (a).value);
		break;
	}
       
	return p;
}

static IDL_tree IDL_unaryop_eval_fixed (enum IDL_unaryop op, IDL_tree a)
{
	IDL_tree p = NULL;

	assert (IDL_NODE_TYPE (a) == IDLN_FIXED);

	switch (op) {
	case IDL_UNARYOP_PLUS:
		p = IDL_fixed_new (IDL_FIXED (a).value);
		break;

	default:
		break;
	}
       
	return p;
}

static IDL_tree IDL_unaryop_eval_float (enum IDL_unaryop op, IDL_tree a)
{
	IDL_tree p = NULL;

	assert (IDL_NODE_TYPE (a) == IDLN_FLOAT);

	switch (op) {
	case IDL_UNARYOP_PLUS:
		p = IDL_float_new (IDL_FLOAT (a).value);
		break;

	case IDL_UNARYOP_MINUS:
		p = IDL_float_new (-IDL_FLOAT (a).value);
		break;

	default:
		break;
	}
       
	return p;
}

static IDL_tree IDL_unaryop_eval (enum IDL_unaryop op, IDL_tree a)
{
	switch (IDL_NODE_TYPE (a)) {
	case IDLN_INTEGER: return IDL_unaryop_eval_integer (op, a);
	case IDLN_FIXED: return IDL_unaryop_eval_fixed (op, a);
	case IDLN_FLOAT: return IDL_unaryop_eval_float (op, a);
	default: return NULL;
	}
}

IDL_tree IDL_resolve_const_exp (IDL_tree p, IDL_tree_type type)
{
	gboolean resolved_value = FALSE, die = FALSE;
	gboolean wrong_type = FALSE;

	while (!resolved_value && !die) {
		if (IDL_NODE_TYPE (p) == IDLN_IDENT) {
			IDL_tree q = IDL_NODE_UP (p);
			
			assert (q != NULL);
			if (IDL_NODE_UP (q) &&
			    IDL_NODE_TYPE (IDL_NODE_UP (q)) == IDLN_TYPE_ENUM) {
				p = q;
				die = TRUE;
				break;
			} else if (IDL_NODE_TYPE (q) != IDLN_CONST_DCL) {
				p = q;
				wrong_type = TRUE;
				die = TRUE;
			} else
 				p = IDL_CONST_DCL (q).const_exp;
		}
		
		if (p == NULL ||
		    IDL_NODE_TYPE (p) == IDLN_BINOP ||
		    IDL_NODE_TYPE (p) == IDLN_UNARYOP) {
			die = TRUE;
			continue;
		}
		
		resolved_value = IDL_NODE_IS_LITERAL (p);
	}

	if (resolved_value &&
	    type != IDLN_ANY &&
	    IDL_NODE_TYPE (p) != type)
		wrong_type = TRUE;
	
	if (wrong_type) {
		yyerror ("Invalid type for constant");
		IDL_tree_error (p, "Previous resolved type declaration");
		return NULL;
	}

	return resolved_value ? p : NULL;
}

void IDL_queue_new_ident_comment (const char *str)
{
	g_return_if_fail (str != NULL);

	__IDL_new_ident_comments = g_slist_append (__IDL_new_ident_comments, g_strdup (str));
}

/*
 * Local variables:
 * mode: C
 * c-basic-offset: 8
 * tab-width: 8
 * indent-tabs-mode: t
 * End:
 */

